;********************************************************************
;AV5K.ASM
;Kernel symbol table - followed by
;Kernel code Avise5 Interpreter, Flash>=16k(combined rcall/call-Opcodes)
;16 Bit Stack, 16 Bit Token
;Subroutine threaded user code
;********************************************************************

.MACRO _READ_EEPR_SYMB
;read internal EEPROM in general:
;Address in ZH,ZL, return in r0. TEMP1 is not destroyed
	call addressIntEep
	in r0,EEDR
.ENDMACRO

;--------------------------------------------------------------------

;####################################################################

SYMBOLTABLE:

;AVISE primary operators names
;elementary Mathematics
	.DB 4,"DROP",0
	  jmp DROP
	.DB 3,"DUP"
	  jmp DUP
	.DB 4,"SWAP",0
	  jmp SWAPP
	.DB 4,"OVER",0
	  jmp OVER
	.DB 3,"ROT"
	  jmp ROT
	.DB 4,"-ROT",0
	  jmp DNROT
	.DB 4,"PICK",0
	  jmp PICK
	.DB 4,"ROLL",0
	  jmp ROLL
	.DB 6,"INJECT",0
	  jmp INJECT
	.DB 1,"+"
	  jmp ADDD
	.DB 2,"1+",0
	  jmp INCT
	.DB 1,"-"
	  jmp SUBB
	.DB 2,"1-",0
	  jmp DECT
	.DB 1,"*"
	  jmp STARSIG
	.DB 1,"/"
	  jmp DIVSIG
	.DB 3,"MOD"
	  jmp MODSIG
	.DB 2,"*/",0
	  jmp STASL
	.DB 5,"*/MOD"
	  jmp STASMOD

;logical operations and special math
;-----------------------------------
	.DB 3,"ABS"
	  jmp ABSS
	.DB 5,"SHIFT"			;TOS bit15set:shift right, else shift left
	  jmp SHIFTT
	.DB 3,"AND"				;bitwise logic operation
	  jmp ANDD
	.DB 2,"OR",0            ;bitwise logic operation
	  jmp ORR
	.DB 3,"XOR"             ;bitwise logic operation
	  jmp XORR
	.DB 3,"NOT"             ;one's complement
	  jmp NOTT
	.DB 3,"+/-"             ;two's complement
	  jmp NEGG
	.DB 4,"BSET",0
	  jmp BSETT
	.DB 4,"BCLR",0
	  jmp BCLRR
	.DB 4,"BTST",0
	  jmp BTST
	.DB 6,"RANDOM",0		;TOS=xorshift16 from RandomH,RandomL as seed
	  jmp RANDOMM
	.DB 5,"CARRY"
	  jmp CARRYY

;compare
;-------
	.DB 2,"==",0			;check for "EQUAL"
	  jmp EQUAL
	.DB 2,"!=",0            ;check for "UNEQUAL"
	  jmp UNEQU
	.DB 2,"0=",0            ;Boolean Negation
	  jmp ZEQ
	.DB 1,">"
	  jmp GRTR
	.DB 2,"U>",0
	  jmp UGRTR
	.DB 2,">=",0
	  jmp GRTREQ
	.DB 1,"<"
	  jmp LESS
	.DB 2,"U<",0
	  jmp ULESS
	.DB 2,"<=",0
	  jmp LESSEQ

;memory access
;------------------
	.DB 1,"W"
JWRITEE:  jmp WRITEE
	.DB 3,"WDM"
	  jmp WRITEDM
	.DB 5,"WREEP"
JWRITEEPR:	jmp WRITEEPR
	.DB 1,"R"
	  jmp READD
	.DB 3,"RDM"
	  jmp READDM

	.DB 0x43,"VAR"
	  jmp VARR
	.DB 2,"VA",0
	  jmp VARA
	.DB 2,"VB",0
	  jmp VARB
	.DB 2,"VC",0
	  jmp VARC
	.DB 5,"ARRAY"
	  jmp ARRAYY
	.DB 0x45,"CONST"
	  jmp CONSTT
	.DB 0x45,"RECON"
	  jmp RECON
	.DB 0x46,"CODEOF",0
	  jmp CODEOF
	.DB 5,"VCALL"
	  jmp VCALL

;Comm I/O functions
;------------------
	.DB 4,"KEY?",0
	  jmp KEYQ
	.DB 3,"KEY"
	  jmp KEY
	.DB 4,"EMIT",0
	  jmp EMIT
	.DB 1,"."
	  jmp DOT
	.DB 2,".H",0
	  jmp DOTHEX
	.DB 2,".D",0
	  jmp DOTDECI
	.DB 2,".U",0
	  jmp DOTUNSIG
	.DB 0xC2,".",0x22,0      ;0x22 = "
	  jmp DOTSTRING
	.DB 2,"DZ",0
JDECIM:		jmp DECIM
	.DB 2,"HX",0
JHEXX:	  	jmp HEXX
#if ((CPU==644) || (CPU==1284) || (CPU==3244))
	.DB 6,"U1BAUD",0
	  jmp USART1BAUD
	.DB 4,"RX1?",0
	  jmp RX1Q
	.DB 3,"RX1"
	  jmp U1RX
	.DB 3,"TX1"
	  jmp U1TX
	.DB 5,"NOBAK"
	  jmp NOBAK
#endif
#if (CPU==3244)
	.DB 0x43,"VID"
	  jmp setVID
	.DB 0x43,"PID"
	  jmp setPID
#endif

;Time/Delay functions
;--------------------
	.DB 2,"MS",0
	  jmp MSWAIT
	.DB 3,"TIX"
	  jmp TIX
	.DB 4,"TIME",0
	  jmp TIME

;I/O acess
;---------
	.DB 2,"IP",0
	  jmp PBIH
	.DB 2,"IZ",0
	  jmp PBIZ
	.DB 2,"OH",0
	  jmp PBOH
	.DB 2,"OL",0
	  jmp PBOL
	.DB 2,"PH",0
	  jmp PORTH
	.DB 2,"PL",0
	  jmp PORTL
	.DB 4,"RDIN",0
 	  jmp RDIGIN
	.DB 4,"RADC",0
	  jmp RADC
	.DB 4,"AREF",0
	  jmp AREF
//((CPU==168) ||(CPU==328)):
//CNT uses INT0 - CNT PIN=PD2  ENC Pin=PD5
//((CPU==644) ||(CPU==1284)):
//CNT uses INT2 - CNT PIN=PB2  ENC Pin=PB3
//(CPU== 3244):
//CNT uses INT0 - CNT PIN=PD0  ENC Pin=PD4
//(CPU==32):
//CNT uses INT2 - CNT PIN=PB2  ENC Pin=PB3
	.DB 3,"CNT"
	  jmp CNT0
	.DB 3,"ENC"
	  jmp ENCODE0
	.DB 2,"CZ",0
	  jmp CNT0Z
#if ((CPU==644) || (CPU==1284) || (CPU==3244) ||(CPU==32))
//(CPU==644) ||(CPU==1284):
//CNTX uses INT0 (conflicts with RX1) - CNT PIN=PD2  ENC Pin=PD4
//(CPU==3244):
//CNTX uses INT1 - CNT PIN=PD1  ENC Pin=PD5
//(CPU==32):
//CNTX uses INT0 - CNT PIN=PD2  ENC Pin=PD4
	.DB 4,"CNTX",0
	  jmp CNTXX
	.DB 4,"ENCX",0
	  jmp ENCODEX
	.DB 3,"CXZ"
	  jmp CNTXZ
#endif
	.DB 4,"PWM1",0
	  jmp PWM1
	.DB 6,"WAVEHI",0
	  jmp WAVEHI
	.DB 4,"WAVE",0
	  jmp WAVE
#if (CPU==3244)
	.DB 4,"PWM3",0
	  jmp PWM3
#else
	.DB 4,"PWM2",0
	  jmp PWMM2
#endif
	.DB 7,"INITSPI"
	  jmp INITSPI
	.DB 3,"SPI"
	  jmp SPI

;debug and support functions
;---------------------------
	.DB 2,".S",0
	  jmp DOTS
	.DB 3,".RS"
	  jmp DOTRS
	.DB 0x43,"OPS"
	  jmp KERNELOPS
	.DB 0x44,"USER",0
	  jmp USEROPS
	.DB 0x43,"SEE"
	  jmp SEE
	.DB 0x43,"MEM"
	  jmp MEM
	.DB 2,"FS",0
	  jmp FLUSHH
	.DB 0x46,"FORGET",0
	  jmp FORGET
	.DB 5,"ABORT"
	  jmp ABORT
	.DB 0x47,"AUTOEXE"
	  jmp AUTOEXE

;System Management
;------------------
#if (CPU!=3244)
	.DB 5,"SLEEP"
	  jmp SLEEPP
#endif
#ifdef SPEED_7M
	.DB 5,"SPEED"
	  jmp SPEED
#endif
#ifdef SPEED_1M8
	.DB 5,"SPEED"
	  jmp SPEED
#endif
	.DB 3,"LED"
	  jmp LEDMODE
	.DB 0x42,"QT",0
	  jmp QUIET

;general structuring functions
;----------------------------
	.DB 0xC2,"IF",0
	  jmp IFF
	.DB 0xC4,"ELSE",0
	  jmp ELSEE
	.DB 0xC4,"THEN",0
	  jmp THENN
	.DB 0xC2,"DO",0
	  jmp DOO
	.DB 0xC5,"UNTIL"
	  jmp UNTIL
	.DB 0xC5,"WHILE"
	  jmp WHILE
	.DB 0xC5,"AGAIN"
	  jmp AGAIN
	.DB 0xC3,"FOR"
	  jmp FORR
	.DB 0xC4,"LOOP",0
	  jmp LOOPP
	.DB 0x85,"BREAK"
	  jmp BREAKK
	.DB 0x85,"CONTI"
	  jmp CONTI
	.DB 0x86,"RETURN",0
	  jmp RETURN

;compiler functions
;------------------
	.DB 0x41,":"
	  jmp COLON
NSEMIS:	.DB 0xC1,";"
JSEMIS:	jmp SEMIS

;internal functions, for debug information only
;----------------------------------------------
	.DB 0x85,"doLIT"
JDOLIT:		jmp DOLIT
	.DB 0x85,"doSTR"
JDOSTR:	  	jmp DOSTR
	.DB 0x84,"doIF",0
JDOIF:		jmp DOIF			;=IFNOTGOO
NDOELSE: .DB 0x86,"doELSE",0	;=GOO
JDOELSE:	jmp DOELSE
	.DB 0x84,"doDO",0	
JDODO: 		jmp DODO
	.DB 0x87,"doWHILE"			;=IFGOO
JDOWHILE: jmp DOWHILE
	.DB 0x87,"doUNTIL"
JDOUNTIL: jmp DOUNTIL			;=IFNOTGOO
	.DB 0x87,"doAGAIN"
JDOAGAIN: jmp DOAGAIN			;=GOO
	.DB 0x85,"doFOR"
JDOFOR:	  	jmp DOFOR
	.DB 0x86,"doLOOP",0
JDOLOOP:	jmp DOLOOP
	.DB 0x86,"RS-1UP",0
JRS1UP:		jmp RS1UP
	.DB 0x86,"RS-4UP",0
JRS4UP:		jmp RS4UP
	.DW 0xFFFF

; Flash-Handling
;===============

initCbuf:		;***************************************************
;*******************************************************************
;calculation Delta COP-CBUF
	mov r24,PAGELO
	mov r25,PAGEHI
	subi r24,LOW(CBUF)
	sbci r25,HIGH(CBUF)
	sts DELTACFLO,r24
	sts DELTACFHI,r25

	lds CBUFLO,COPLO      	 ;actually addressed compilation in Flash
	lds CBUFHI,COPHI
	lds r24,DELTACFLO
	lds r25,DELTACFHI
	sub CBUFLO,r24
	sbc CBUFHI,r25
	ldi YL,LOW(CBUF) 
	ldi YH,HIGH(CBUF)
	mov ZL,PAGELO
	mov ZH,PAGEHI
	ldi r25,16
ICB10:						;copy new 2 Flash pages into CBUF
	wdr
	lpm r24,Z+
	cp YL,CBUFLO
	brcs ICB20
	ldi r24,0xFF			;fill end of actual code as "unburned"
ICB20:
	mov r25,YH
	st Y+,r24
	cpi r25,HIGH(CBUFTOP)
	brcs ICB10
	ret


cbuf2Flash:   ;******************************************************
;re-copy CBUF into actual page of Usercode-area
;use CBUF base address and page base address for re-storage
;********************************************************************
	push XL
	push XH
	mov ZL,PAGELO	
	mov ZH,PAGEHI
	ldi XH,HIGH(CBUF)       ;start address of compiled code in SRAM
	ldi XL,LOW(CBUF)
	call progFlash

;make differece of CPU
#if (FLASHPAGE==128)
//PAGESIZE=128 words =256 bytes
	mov r24,CBUFHI
	cpi r24,HIGH(CBUF) + 1
	brcc CBF10
	rjmp CBF80
CBF10:
	inc PAGEHI				;address and burn next page
	mov ZL,PAGELO			;set next Flash page for future operation
	mov ZH,PAGEHI
	ldi XH,HIGH(CBUF) + 1     
;CPU type specific
	clr XL
	call progFlash
#else  						
//PAGESIZE=64 words =128 bytes
	mov r24,CBUFLO
	cpi r24,0x80
	brcc CBF10
	rjmp CBF80
CBF10:
	clr r25
	ldi r24,0x80
	add PAGELO,r24			;address and burn next page
	adc PAGEHI,r25
	mov ZL,PAGELO			;set next Flash page for future operation
	mov ZH,PAGEHI
	ldi XH,HIGH(CBUF)       
;CPU type specific
	ldi XL,0x80
	call progFlash
#endif

;calculate new Delta COP-CBUF
	mov r24,PAGELO
	mov r25,PAGEHI
	subi r24,LOW(CBUF)
	sbci r25,HIGH(CBUF)
	sts DELTACFLO,r24
	mov XL,r24				;use temporarily
	sts DELTACFHI,r25
	mov XH,r25
	lds r24,COPLO
	lds r25,COPHI
	sub r24,XL
	sbc r25,XH
	mov CBUFLO,r24
	mov CBUFHI,r25
	ldi XL,LOW(CBUF)
	ldi XH,HIGH(CBUF)
	mov ZH,PAGEHI
	mov ZL,PAGELO
	clr r25
CBF20:
	wdr
	lpm r24,Z+
	st X+,r24
	dec r25
	brne CBF20
CBF80:
	pop XH
	pop XL
	ret 


okMsg:
	sbrs YFLAGS,NUMVABC		;suppress double ok msg
	rjmp OKM10
	cbr YFLAGS,m_NUMVABC
	ret
OKM10:
	ldi r24,LOW(OKSTR*2)  
	jmp pageSendString

cmpiMsg:
	ldi r24,LOW(CMPISTR*2)
	jmp pageSendString
memErrMsg:
	ldi r24,LOW(MEMSTR*2)
	jmp genError

nameErrMsg:					;modified 09Sept23
	ldi r24,LOW(TOKENSTR*2) 
	jmp pageSendString

paramErrMsg:
	ldi r24,LOW(PARAMSTR*2)
	jmp pageSendString

stackErrMsg:
	ldi r24,LOW(STACKSTR*2)
	jmp genError

runErrMsg:
	ldi r24,LOW(RUNSTR*2)
	jmp genError

abortMsg:
	ldi r24,LOW(ABORTSTR*2)
	jmp pageSendString

compErrMsg:
	ldi r24,LOW(COMPOSTR*2)
	jmp pageSendString

syntaxErrMsg:
	ldi r24,LOW(SYNTAXSTR*2)
genError:
	rcall pageSendString
	ldi r24,LOW(ERRSTR*2)
	jmp pageSendString


INITIOREADY:  ; *****************************************************
; *******************************************************************
;read autostart token from.EEPROM
;if (XAUTO) = 0xFFxx, then no Autostart programmed, else vector to code
;(XAUTO) and COM(XAUTO+1) must be equal,else no Autostart
; (XAUTO+2) and COM(XAUTO+3) must be equal,else no Autostart

	rcall restoreCop
	sts STARTCOPL,PAGELO
	sts STARTCOPH,PAGEHI
	rcall initCbuf

	ldi r24,LOW(HISTRING*2)
	rcall pageSendString
	ldi r24,LOW(TYPESTR*2)
	rcall pageSendString
	ldi r24,LOW(SPEEDSTR*2)
	rcall pageSendString
	cbr AVIFLAGS,m_NOLEADS

	ldi ZL,LOW(XAUTO)
	ldi ZH,HIGH(XAUTO)
	_READ_EEPR_SYMB
	mov YH,r0
	cpi YH,0xFF             ;virgin
	breq INI10
	adiw ZL,1
	_READ_EEPR_SYMB
	com r0
	cp r0,YH               
	brne INI10              ;Error
	adiw ZL,1
	_READ_EEPR_SYMB
	mov YL,r0
	adiw ZL,1
	_READ_EEPR_SYMB
	com r0
	cp r0,YL
	brne INI10              ;Error

	ldi r24,LOW(AUTOSTRING*2)
	rcall pageSendString
	rcall sendSPACE
	mov r25,YH
	mov r24,YL
	call token2Str	
	rcall sendCRR

	mov ZH,YH				;Z is Program Counter
	mov ZL,YL
	icall                   ;start AUTOEXE-function
INI10:
;init Datastack pointer HIGH word

	clr r25

;...continue

;--------------------------------------------------------------------

;interpreter main loop:
;---------------------
QUIT:
#if (CPU==3244)
	sbrs YFLAGS,BAKDOTS		;lock Forth main loop
	rjmp QIT02 				;while background process is waiting for input
	wdr
	rjmp QUIT
QIT02:
#endif
	sbrs YFLAGS,GETVABC		;lock Forth main loop
	rjmp QIT05 				;while background process is waiting for input
	wdr
	rjmp QUIT
QIT05:

;Terminal-Interpreter
;check error flags: if=0  respond OK
;                	else respond, ? + error text
	rcall checkStack
QIT10:
	tst r25                 ;error mask is transferred in r25
	breq QIT20

	rcall sendSPACE			;09Sept23
	ldi r24,'?'
	rcall sendCmdByte
	rcall sendSPACE

	sbrc r25,RUNERR
	call runErrMsg
	sbrc r25,MEMERR
	call memErrMsg
	sbrc r25,PARAMERR
	call paramErrMsg
	sbrc r25,STRTOKERR
	call nameErrMsg
	sbrc r25,STACKERR
	call stackErrMsg
	sbrc r25,ABORTED
	call abortMsg
	sbrc r25,COMPONLY
	call compErrMsg
	sbrc r25,SYNTXERR
	call syntaxErrMsg

	rcall ABRT
	clr r25
	rjmp QIT80

QIT20:   	 
	sbrs AVIFLAGS,COMPILE
	call okMsg
	sbrc AVIFLAGS,COMPILE
	call cmpiMsg
	ldi r24,'D'					;after reset,start with decimal number base
	sbrc AVIFLAGS,HEX			;may be changed with AUTOEXE
	ldi r24,'H'
	rcall sendCmdByte
#ifdef SPEED_7M
	ldi r24,'+'	
	sbrc XFLAGS,HISPEED			;signal actual CPU speed
	rcall sendCmdByte
#endif
#ifdef SPEED_1M8
	ldi r24,'+'	
	sbrc XFLAGS,HISPEED			;signal actual CPU speed
	rcall sendCmdByte
#endif
QIT80:
	rcall sendCRR


query:    ;**********************************************************
; receive text line from terminal and strore in TIB (=terminal input buffer)
; max. 80 chars
;********************************************************************
	ldi YH,HIGH(TIB)
	ldi YL,LOW(TIB)
	mov STRSTART,YL			;reset pointer
QRY10:    
	cpi YL,LOW(TIBTOP)
	brcs QRY20           
	rjmp memoryError		;jumps back to QUIT

QRY20:   
	sbrc YFLAGS,GETVABC
	rjmp QUIT
	wdr
	call pullCmdRxBuf     	;returns char in TEMP1 and success in T-flag
	brtc QRY20
	cpi TEMP1,0x7F			;ignore 0x7F and non 7bit ASCII characters
	brcc QRY10
	cpi TEMP1,CRR
	breq QRY75    			;EOL, start evaluation
	cpi TEMP1,BKSP
	brne QRY30
	cpi YL,LOW(TIB)
	breq QRY30               ;ignore BS at begin of line
	dec YL                  ;clear character in TIB
	rcall termBKSP          ;clear character on terminal
	rjmp QRY10
QRY30:						
	cpi TEMP1,0x20			;ignore control characters else
	brcs QRY10

;check for "//"
	cpi TEMP1,0x2F			;'/'
	brne QRY60
	mov TEMP2,TEMP1			;keep in mind
	sbrc AVIFLAGS,TQUIET
	rjmp QRY40
;echo to terminal
#if (CPU==3244)
	mov r24,TEMP1
	rcall sendCmdByte
#else
  #if (CPU==32)
QRY35:
	sbis UCSRA,UDRE
	rjmp QRY35
	out UDR,TEMP1			;emmulate "sendCmdByte"
  #else
QRY35:
	lds r25,UCSR0A
	sbrs r25,UDRE0
	rjmp QRY35
	sts UDR0,TEMP1			;emmulate "sendCmdByte"
  #endif
#endif

;get next byte from terminal
QRY40:
	sbrc YFLAGS,GETVABC
	rjmp QUIT
	wdr
	call pullCmdRxBuf
	brtc QRY40	
	cpi TEMP1,0x2F
	brne QRY45
	mov r24,TEMP1
	rcall sendCmdByte		;echo to terminal for input confirmation
	rjmp QRY55
QRY45:
;not '/': handle as normal byte
	st Y+,TEMP2           	;store first byte in TIB and increment
	rjmp QRY60				;handle second byte

QRY55:
;delete '//' comment
	wdr 
	sbrc YFLAGS,GETVABC
	rjmp QUIT
	call pullCmdRxBuf
	brtc QRY55
	cpi TEMP1,CRR
	breq QRY75
	rjmp QRY55

QRY60:
	cpi TEMP1,CRR
	breq QRY75
	st Y+,TEMP1              ;store 'normal' byte in TIB and increment 
;echo to terminal
	sbrc AVIFLAGS,TQUIET
	rjmp QRY10
#if (CPU==3244)
	mov r24,TEMP1
	rcall sendCmdByte
#else
  #if (CPU==32)
QRY70:
	sbis UCSRA,UDRE
	rjmp QRY70
	out UDR,TEMP1			;emmulate "sendCmdByte"
  #else
QRY70:
	lds r25,UCSR0A
	sbrs r25,UDRE0
	rjmp QRY70
	sts UDR0,TEMP1			;emmulate "sendCmdByte"
  #endif
#endif
	rjmp QRY10   	      	;get next input

QRY75:
	ldi TEMP1,SPACE
	st Y+,TEMP1          	;store SPACE as final delimiter
	clr TEMP1
	st Y+,TEMP1             ;store NULL as EOL marker 07.12.02
	cpi YL,LOW(TIB+1)       ;TIB is empty (1st char is SPACE put by CRR)
	brcc QRY80           
	clr r25                 ;mark error-free
	rjmp QUIT

QRY80: 

;continue immediately with

eval:    ;***********************************************************
;execute received text line
;********************************************************************
;scan first stringtoken:
	ldi ZL,LOW(TIB)
	ldi ZH,HIGH(TIB)
	mov STRSTART,ZL 

parseExpression:  ;************************
	rcall getToken          ;jumps directly to QUIT in case or error
							;and clears T-Flag if EOL
	brts PEX10              ;jump if token i.e. no End_of_Line
;else EOL token found (empty line)
	clr r25
	rjmp QUIT			
PEX10:
	rcall executeToken      ;execute token immediately.No Lookahead
	clr r25                 ;mark error-free. Does no harm to scanNext
	rcall checkStack        ;jumps directly to QIT10 in case of error
	rjmp parseExpression

;end of interpreter main loop:
;this loop is completely executed on MAIN level

;------------------------------------------------------------------------


termBKSP:   ;********************************************************
;handle backspace cursor on terminal
;********************************************************************
	ldi r24,BKSP            ;clear redundant characters on terminal
	rcall sendCmdByte
	rcall sendSPACE
	ldi r24,BKSP
	rcall sendCmdByte
	ret


getToken:   ;********************************************************
; update: STRSTART,STRINGLEN
; return:r0=TokenType
;        TEMP5=Token,VAR,CONST High, TEMP2=Token,VAR,CONST Low
;        T-Flag=1 normal, =0 EOL
;********************************************************************
	clr r25                 ;mark error-free. Does no harm to scanNext
	rcall checkStack        ;jumps directly to QIT10 in case of error
	set                     ;causes scanNext to return at EOL with T=0
	rcall scanNext          ;get Z=pointer to next text word in query
	brtc GET85              ;jump when EOL
GET05:  
	tst TEMP2
	brne GET80              ;delimiting token found, description ready
	ldi YH,HIGH(TIB)
	mov YL,ZL

;parse token code and type, check errors
	clr r0                  ;assume no special behaviour,
							;may be changed by "findToken"
	push YL                 ;will be TIB pointer
	rcall checkNum          ;puts valid number to ZH,ZL
	pop YL                  ;restore
	brtc GET10              ;jump if not a valid number

	ldi r25,m_CONSTATTRIB   ;used from here on to mark NUMBER type,too
	mov r0,r25
	mov r24,ZL
	mov TEMP2,ZL            ;provisionally
	mov TEMP5,ZH            ;provisionally
	rjmp GET80
GET10:
;not a number: scan through symbol table
	rcall findToken         ;Token(HighByte)in TEMP5
							;Token(LowByte) in TEMP2
							;Flags&Count in r0
GET80:  
	set
GET85:
	ret


executeToken:   ;****************************************************
; Parameter:r0=TokenType,TEMP5=Token,VAR,CONST High,TEMP2=Token,VAR,CONST Low
;********************************************************************
	tst r0
	brne ECT05              ;r0=0 is a Dummy Token. Nothing to execute
	ret

ECT05:
	sbrs r0,CONSTATTRIB
	rjmp ECT20
	sbrs AVIFLAGS,COMPILE   ;skip if in compiling state
	rjmp ECT10
	ldi ZH,HIGH(JDOLIT)		;compile CONST
	ldi ZL,LOW(JDOLIT)
;recalculate Jumptable address to Flash code address
	call compiXToken       ;quivalent DOLIT kompilieren
	ret                     ;success: continue scanning

ECT10:
;interpreting state: put parameter on stack
	st -X,TOSH
	st -X,TOSL
	mov TOSH,TEMP5
	mov TOSL,TEMP2
	ret                     ;success: continue scanning

ECT20:
	sbrs r0,VARATTRIB
	rjmp ECT60

handleVar:  ;**************************
;make difference LOC and GLOB VAR by use of COMPO flag
;**************************************
	sbrs AVIFLAGS,COMPILE  	;skip if in compiling state
	rjmp ECT40
	ldi ZH,HIGH(JDOLIT)
	ldi ZL,LOW(JDOLIT)		;compile VAR
;recalculate Jumptable address to Flash code address
	call compiXToken       ;compile DOLIT equivalent
	ret

ECT40:
;interpreting state: put variable parameter on stack
	st -X,TOSH              ;interpreting: push literal on datastack
	st -X,TOSL
	mov TOSH,TEMP5
	mov TOSL,TEMP2
	ret

ECT60:
;"normal" Token value is returned in TEMP5/TEMP2
;continue immediately.......

processToken:   ;****************************************************
; Parameter:r0=TokenType
;           TEMP5=Token,VAR,CONST High,TEMP2=Token,VAR,CONST Low
;********************************************************************
	sbrc AVIFLAGS,COMPILE   ;skip if interpreting
	rjmp PCT50
	sbrs r0,COMPO        	;may be set by "findToken"
	rjmp PCT70              ;INTERPRET this token
							;returns to EXIT2CON
	ldi r25,m_COMPONLY
	rjmp QUIT

PCT50:                     
;Compiling:
	sbrc r0,IMMEDIATE    	;may be set by "findToken"
	rjmp PCT70              ;perform immediately (e.g.compile structures)

	tst TEMP5
	brne PCT60              ;jump if User Token
	mov ZH,TEMP5
	cpi ZH,HIGH(JDECIM)
	brne PCT55
	cpi TEMP2,LOW(JDECIM)   ;special case number base: compile and immediate
	brne PCT55              ;at same time
	cbr AVIFLAGS,m_HEX
	rjmp PCT60
PCT55:
	mov ZH,TEMP5
	cpi ZH,HIGH(JHEXX)
	brne PCT60
	cpi TEMP2,LOW(JHEXX)
	brne PCT60
	sbr AVIFLAGS,m_HEX
PCT60:
	mov ZH,TEMP5
	mov ZL,TEMP2
//replace call to Jumptable with call to Flash code
//saves 2 clock pulses when executing subroutine threaded user code
	call compiCALL
	ret                     ;token compiled

PCT70:
;INTERPRETER:
	mov ZH,TEMP5
	mov ZL,TEMP2
	icall					;interpreter calls simplified via symbol table
	
	ret


checkStack:    ;*****************************************************
;********************************************************************
	cpi XH,HIGH(DATASTACK)          ;stack is allowed in a single page only
	brne CKS60
	cpi XL,LOW(DATASTACK+1)         ;test Stack underflow
	brcc CKS60
	cpi XL,LOW(RETURNSTACK+4)       ;test Stack overflow
	brcs CKS60
	ret                     		;stack ok

CKS60:
	ori r25,m_STACKERR
	rjmp QIT10


scanNext:    ;*******************************************************
;scan SPACE delimited text in TIB
;Parameter: STRSTART = start of actual scan
;           T flag set=in case of EOL return with T clear
;                      else jump directly to QUIT
;Return: STRINGLEN
;        ZL = actual STRSTART
;        STRSTART = scanpointer updated for next Scan
;        T-Flag=1:normal, =0:EOL
;        TEMP5=0 delimiting Token is Kernel Token
;        TEMP2:=0 or Code-Low of delimiting token
;*******************************************************************
	clr TEMP5
	clr TEMP2               ;assume not delimiter interpreted as token
	mov ZL,STRSTART         ;actual<--next
	ldi ZH,HIGH(TIB)
SN2:   
	mov STRSTART,ZL     	;keep in mind, but update at multiple SPACE
	clr STRINGLEN

SN10:   
	ld r25,Z
	tst r25
	brne SN12
;r25=0 is marking End_of_Line as well as Error_Free
	brtc SN11               ;T-Flag controls mode of exit
	clt                     ;NULL byte marks End_Of_Line
	ret
SN11:   
	rjmp QUIT           	;NULL byte marks End_Of_Line
SN12:   
	set
	cpi r25,0x61
	brcs SN15               ;Upper Case conversion hierher aus QUERY
	cpi r25,0x7B
	brcc SN15
	subi r25,0x20           ;convert into upper case
	st Z,r25                ;restore in TIB
SN15:

	adiw ZL,1
	cpi r25,SPACE
	breq SN20

	inc STRINGLEN
	rjmp SN10
SN20:
	tst STRINGLEN           ;don't evaluate empty strings
	breq SN2
	mov ZL,STRSTART         ;restore
	add STRSTART,STRINGLEN
	inc STRSTART            ;point to next stringtoken
	ret


findToken:    ;******************************************************
; parameters:   YL = TIB pointer
;               STRINGLEN (undestroyed)
; return:       TEMP5 = token value High Byte
;               TEMP2 = Token value Low Byte
;               r0 = count byte with token property flags
;               ZH,ZL = pointer to CountByte in SymbolTable
;********************************************************************
	ldi ZH,HIGH(SYMBOLTABLE*2)   
	ldi ZL,LOW(SYMBOLTABLE*2)
	rcall findKernelToken
	brts FT40
	rcall findUserToken

	brtc FT70
FT40:
	ret

FT70:
;no matching string found
	rjmp nameError


findKernelToken:    ;***************************************************
; parameters:   YL = TIB pointer (undestroyed)
;               ZH,ZL = kernel program memory pointer
;               STRINGLEN (undestroyed)
; return:       ZH,ZL = pointer to count byte of found entry
;               r0 = token property flags and count
;               TEMP1 = count
;               TEMP5= token value high Byte (=0 @ kernel token)
;               TEMP2= token value low byte
;               r24:CONST Low Byte
;               T-Flag: set in case of success, else cleared
; 				Kernel-Token = direkte Adresse im WORD-Format (.DW)
;********************************************************************
FKT10:
	wdr                     ; -- search in symbol table may take too long
	lpm
	mov r25,r0              ;r0 is next CountByte
	cpi r25,0xFF
	brne FKT15
	rjmp FKT70              ;jump if end of table
FKT15:  
	mov TEMP1,r0        	;keep count byte
	andi TEMP1,0x0F         ;eliminate control flags
	cp TEMP1,STRINGLEN
	breq FKT40
FKT20:  
	subi TEMP1,(-5)     	;add 5 for count byte, jmp code
	sbrs r0,0               ;(only in kernel symbol table)
	inc TEMP1               ;adjustment for null byte needed by assembler
	add ZL,TEMP1
	clr TEMP1
	adc ZH,TEMP1            ;16 bit adjustment of pointer
	rjmp FKT10

FKT40:  
	push ZH                 ;save pointer to symbol table
	push ZL
	push YL                 ;save TIB pointer
	push r0                 ;save count byte with flags

FKT50:  
	adiw ZL,1               ;16 bit increment of Byte pointer
	lpm
	ld r25,Y+
	cp r25,r0
	brne FKT60
	dec TEMP1
	brne FKT50
;success matching string found
	pop r0                  ;restore flags 
	sbrs r0,0               
	adiw ZL,1               ;adjustment for null byte needed by assembler
							;now between name and token bytes
	adiw ZL,1
	mov TEMP2,ZL            ;get token address low byte (byte address !)
	mov TEMP5,ZH            ;get high byte
	lsr TEMP5				;word address now
	ror TEMP2
	ldi r24,1 				;provisorical
	pop YL                  ;restore TIB pointer
	pop ZL                  ;restore pointer
	pop ZH
	set
	ret                     ;READY

FKT60:
;no success -- search on
	pop r0                  ;reset pointers to start of this entry
	mov TEMP1,r0
	andi TEMP1,0x0F
	pop YL
	pop ZL
	pop ZH
	rjmp FKT20
FKT70:
;no matching String found
	clt
	ret


findUserToken:    ;***************************************************
; parameters:   YL = TIB pointer (undestroyed)
;               STRINGLEN (undestroyed)
; destroys:     r1,r25,TEMP3,TEMP4
; return:       ZH,ZL = pointer to count byte of found entry
;               r0 = token property flags and count
;               TEMP1 = count
;               TEMP5= User token High Byte in WORD Format
;               TEMP2= User Token Low Byte in WORD Format
;               T-Flag: set in case of success, else cleared
;get end of table by compare with USYMBHEAD
;********************************************************************
;search starting from oldest entries but up to end of table
;return last=newest hit-->overloading possible
	push CBUFLO				;temporary misuse
	clr TEMP5				;returns !=0 in case of hit
	clr r24
	clt 					;gets set at first hit
	ldi ZH,HIGH(USERSYMBTAB)
	ldi ZL,LOW(USERSYMBTAB)
FUT10:  
	wdr
	mov TEMP3,ZL			;actual pointer in UserSymbolTable
	mov TEMP4,ZH            ;keep in mind

	lds r25,USYMBHEADH      
	cp ZH,r25
	brcs FUT15
	brne FUT15
	lds r25,USYMBHEADL
	cp ZL,r25
	brcs FUT15
	rjmp FUT60              ;end of active symbol table reached

FUT15:  
	_READ_EEPR_SYMB
	mov TEMP1,r0
	cpi TEMP1,0xFF
	breq FUT60 				;end of active symbol table reached
	andi TEMP1,0x0F         ;eliminate control flags
	cp TEMP1,STRINGLEN
	breq FUT30
FUT20:
;check next entry
	subi TEMP1,(-3)			;add 3 for: Countbyte, 2 Byte Token
	clr r25
	add ZL,TEMP1
	adc ZH,r25
	cpi ZH,HIGH(INTEEP)
	brcs FUT10				;overflow
	rjmp FUT70				;String not found

FUT30:
;Countbytes value corresponds. Now compare complete string
	push YL
	push r0

FUT40:  
	adiw ZL,1               ;points to first or next char of name
	_READ_EEPR_SYMB
	ld r25,Y+
	cp r25,r0
	brne FUT50
	dec TEMP1
	brne FUT40
;success
	set
	mov r1,TEMP3			;simply keep latest hit in mind
	mov CBUFLO,TEMP4		;simply keep latest hit in mind
	adiw ZL,1
	_READ_EEPR_SYMB
	mov TEMP5,r0            ;return Token|VAR|CONST HighByte
	adiw ZL,1
	_READ_EEPR_SYMB
	mov TEMP2,r0            ;return Token|VAR|CONST LowByte
	pop r24                 ;copy r0 to r24 
	push r24                ;keep in mind for final reconstruction

FUT50:
	pop r0                  ;restore flags
	pop YL                  ;restore TIB pointer
	mov ZL,TEMP3
	mov ZH,TEMP4
	mov TEMP1,r0
	andi TEMP1,0x0F
	rjmp FUT20              ;search for latest hit, don't use elder entries

FUT60:						;end of active symbol table reached
FUT70:						;string not found
	brts FUT80
	pop CBUFLO				;reconstruct
	ret

FUT80:
;success
	mov r0,r24
	mov TEMP1,r24
	andi TEMP1,0x0F
	mov ZL,r1
	mov ZH,CBUFLO
	set						;repeat as precaution
	pop CBUFLO				;reconstruct
	ret


; helper functions:  ------------------------------------------------

checkNum:    ;*******************************************************
; checks if 4-8-places string represents a WORD as Hex or Dezimal number
; small numbers can be written with leading zero or not
; Unitary MINUS sign (w.o.SPACE) is parsed too
; Parameter: Y = TIB Pointer
; Return: 16Bit binary word in ZH(High),ZL(Low)
; In case of success T-bit is set, else it is cleared
;********************************************************************
	push AVIFLAGS
	clt                    	;primarily assume failure
	cbr AVIFLAGS,m_TEMPHEX  ;primarily assume decimal number base
	sbrc AVIFLAGS,HEX
	sbr AVIFLAGS,m_TEMPHEX
	clr ZH
	clr ZL
	ldi r24,1

	ld r25,Y
	cpi r25,'0'				;check for leading 0x
	brne CKN05				;if not, leading zero may be forgotten
	inc YL
	inc r24
	ld r25,Y
	cpi r25,SPACE
	brne CKN02
	rjmp CKN70				;simple '0' number input
CKN02:
	ori r25,0x20			;convert into lower case anyway
	cpi r25,'x'
	brne CKN05
	sbr AVIFLAGS,m_TEMPHEX
	inc YL
	inc r24
	rjmp CKN10
CKN05:
	cpi r25,'$'
	brne CKN08
	inc r24
	inc YL
	sbr AVIFLAGS,m_TEMPHEX
CKN08:
	cpi r25,'&'
	brne CKN10
	inc r24
	inc YL
	cbr AVIFLAGS,m_TEMPHEX
CKN10:
	clr TEMP2               ;pre-assume no unitary minus
	ld r25,Y
	cpi r25,'-'
	brne CKN20
	inc TEMP2               ;marks unary minus
	inc r24
	inc YL
CKN20:
;check for number without prefix
	mov r25,STRINGLEN
	sub r25,r24             ;discount prefix
	sbrc AVIFLAGS,TEMPHEX
	cpi r25,4 ;5            ;pos. hex numbers are max. 4 digits
	sbrs AVIFLAGS,TEMPHEX
	cpi r25,5 ;6    	    ;pos. dec.numbers are max. 5 digits
	brcc CKN80             	;cannot be a number

CKN30:
	ld r24,Y+
	cpi r24,SPACE
	breq CKN60				;terminates number

CKN40:
	clt
	rcall checkDigit
	brtc CKN80
	push r24
	sbrc AVIFLAGS,TEMPHEX
	ldi r24,0x10
	sbrs AVIFLAGS,TEMPHEX
	ldi r24,10
	clr r25
	call starSub
	or TEMP3,TEMP4
	brne CKN50              ;overflow
	pop r24
	add ZL,r24
	clr r24
	adc ZH,r24
	brcc CKN30
	rjmp CKN90				;16bit overflow

CKN50:  
	pop r24
	rjmp CKN90 ;CKN80

CKN60:  
	tst TEMP2               ;test for MINUS
	breq CKN70              ;jump if number is parsed as "positive"
	com ZL
	com ZH
	adiw ZL,1               ;two's complement
CKN70:  
	set
CKN80:
	pop AVIFLAGS
	ret
CKN90:
	rjmp parameterErr


checkDigit:    ;*****************************************************
; Char in r24 is transformed into Hex-Nibble 
; all Chars have been transformed into upper case by "query"
; refuse hex nibbles when decimal number base is active
; set T-Flag in case of success
;********************************************************************
	subi r24,48
	brcs CDI80      ;jump if char < 0x30
	cpi r24,10
	brcs CDI70      ;success if 0x30 <= char <= 0x39
	sbrs AVIFLAGS,TEMPHEX    
	ret             ;if decimal, dont check for hex numbers
	cpi r24,17
	brcs CDI80      ;error if char < 0x41 (='A')
	cpi r24,23      ;error if char >= 0x47 (='G')
	brcc CDI80
	subi r24,7      ;adjust hex nibble
CDI70:  
	set             ;success
CDI80:  
	ret


ABORT:   ;  ( -- )  *************************************************
;********************************************************************
	ldi r24,SPACE
	rcall sendCmdByte
	rcall sendCmdByte 
	ldi r24,'>'
	rcall sendCmdByte          
	rcall abortMsg

;... continue

ABRT:    ;***********************************************************
;********************************************************************
	bst AVIFLAGS,HEX			;HEX may be changed temporarily at compilation
	bld AVIFLAGS,HEXBACK		;refresh

	cbr AVIFLAGS,(m_COMPILE | m_TQUIET)

#if (CPU==3244)
;init USB transmit buffer, is not cyclic
	ldi r25,LOW(EP1_BUF)
	sts EP1_HEAD,r25
	sts EP1_TAIL,r25
;init USB receive buffer
 	ldi r25,HIGH(EP2_BUF)
	sts USBRXHEADH,r25
	sts USBRXTAILH,r25
 	ldi r25,LOW(EP2_BUF)
	sts USBRXHEADL,r25
	sts USBRXTAILL,r25
#else
	ldi r25,LOW(CMDRXBUF)
	sts CMDRXHEADL,r25
	sts CMDRXTAILL,r25
#endif
	clr r25
	out EEARH,r25			;reset EEPROM address pointer
	sts MSCNTL,r25			;terminate MS-process
	sts MSCNTH,r25
		
#ifdef LEONARDO
	cbi PORTD,TXLED         ;switch LED ON
#else
  #if ((CPU==644) || (CPU==1284) || (CPU==32))
	sbi PORTB,LED           ;switch LED ON
  #else
	sbi PORTD,LED           ;switch LED ON
  #endif
#endif

;reconstruct aktual pointer from permanent system variables
	ldi ZH,HIGH(USERSYMBTAB)
	ldi ZL,LOW(USERSYMBTAB)
	_READ_EEPR_SYMB
	com r0
	brne ABR10
;if r0=0xFF then virgin ystem
;then load defaults
	sts USYMBHEADH,ZH
	sts USYMBHEADL,ZL
	ldi r25,LOW(VARBASE)
	sts VARLOW,r25
	ldi r25,HIGH(KERNELTOP*2)	;first assume default values
	sts COPHI,r25
	ldi r25,LOW(KERNELTOP*2)
	sts COPLO,r25
	rjmp ABR20
ABR10:
;not virgin system
	lds ZH,USYMBHEADH
	lds ZL,USYMBHEADL
	ldi TEMP1,0xFF
	rcall burnIntEep        ;re-mark end of symbol table
	adiw ZL,1
	rcall burnIntEep    	;double 9xFF marks end of symbol table
	sbiw ZL,1
	rcall reAddressVars
	rcall restoreCOP
	rcall initCbuf
ABR20:

	ldi INTREG,LOW(RETURNSTACK-2);readjust return stack
	out SPL,INTREG
	ldi INTREG,HIGH(RETURNSTACK-2)
	out SPH,INTREG

	cpi XL,LOW(DATASTACK)
	breq ABR30
	rcall sendCRR
	ldi r24,LOW(FLUSHSTR*2)         
	rcall pageSendString
	rcall dots
ABR30:

;continue:

FLUSHH:  ;  ( -- empty)  ********************************************
;********************************************************************
;init Datastack pointer HIGH word
	ldi XH,HIGH(RETURNSTACK + 2) 	;RETURNSTACK+2 is DataStack deepest item
	ldi XL,LOW(RETURNSTACK + 2)		;operate upwards
	clr TOSH
	clr TOSL
	ldi r25,LOW(DATASTACK + 4)		;clear some reserve
FLU20:
	st X+,TOSL
	cp XL,r25
	brne FLU20
	brcs FLU20
	ldi XH,HIGH(DATASTACK)
	ldi XL,LOW(DATASTACK)
	ret


restoreCOP:   ;******************************************************
;restore COP:
;search in USERSYMBTAB for latest Token w.o. VARATTRIB and/or CONSTATTRIB
;return (Adr(RET)+1) from this = new COPHI,COPLO
;********************************************************************
	ldi r25,HIGH(KERNELTOP*2)  ;initially assume default
	sts COPHI,r25
	mov PAGEHI,r25
	ldi r25,LOW(KERNELTOP*2)
	sts COPLO,r25
	andi r25,0x80
	mov PAGELO,r25

	ldi ZH,HIGH(USERSYMBTAB)
	ldi ZL,LOW(USERSYMBTAB)
	_READ_EEPR_SYMB
	com r0
	brne RCO10
	ret						;Table is empty--> defaults

RCO10:  
	wdr
	_READ_EEPR_SYMB
	mov TEMP1,r0
	cpi TEMP1,0xFF
	breq RCO40              ;end of not-empty table
	andi TEMP1,0x0F         ;eliminate control flags
	mov r25,r0
	andi r25,0xF0
	brne RCO20              ;ignore VAR or CONST at this place
	inc TEMP1
	clr r25
	add ZL,TEMP1
	adc ZH,r25
	_READ_EEPR_SYMB
	adiw ZL,1
	mov TEMP4,r0
	_READ_EEPR_SYMB
	adiw ZL,1
	mov TEMP3,r0
	rjmp RCO30

RCO20:
;check next entry
	subi TEMP1,(-3)			;add 3 for: Countbyte, 2 Byte Token
	clr r25
	add ZL,TEMP1
	adc ZH,r25
RCO30:  
	cpi ZH,HIGH(INTEEP)
	brcs RCO10
	rjmp RCO90				;overflow

RCO40:
	tst TEMP4
	breq RCO80				;no user funktion --> defaults
;now search RET - token
	mov ZH,TEMP4
	mov ZL,TEMP3
	lsl ZL
	rol ZH                  ;WORD-->BYTE-address
RCO50:  
	lpm r24,Z+
	lpm r25,Z+
	cpi r25,0x95            ;Opcode and HighByte RET
	brne RCO50              ;User Token cannot be last one
	cpi r24,0x08
	brne RCO50
;COP is handled in Byte-Format 
	sts COPHI,ZH            ;lrady points two behind RET token

;must be handled CPU-spezific 
	mov PAGEHI,ZH	
	sts COPLO,ZL
#if (FLASHPAGE==128)
	clr r24
	mov PAGELO,r24
#else
//FLASHPAGE = 64
	clr r24
	cpi ZL,0x80
	brcs RCO70
	ldi r24,0x80
RCO70:
	mov PAGELO,r24
#endif

;refill CBUF
	push XL
	push XH
	mov ZL,PAGELO
	mov ZH,PAGEHI
	ldi XL,LOW(CBUF)
	ldi XH,HIGH(CBUF)
#if (FLASHPAGE==128)
	clr r25
#else
//FLASHPAGE=64
	ldi r25,128
#endif
RCO75:
	wdr
	lpm r24,Z+
	st X+,r24
	dec r25
	brne RCO75
	pop XH
	pop XL
RCO80:  
	ret
RCO90:  
	rjmp memoryError


AUTOEXE:   ;( -- ; name)  *******************************************
;invalid 'name' argument deletes AUTOEXE function (e.g. with AUTOEXE 0 CRR)
;User Functions only
;********************************************************************
; as precaution first de-init old entry
	ldi ZL,LOW(XAUTO)
	ldi ZH,HIGH(XAUTO)
	ldi TEMP1,0xFF
	rcall burnIntEep
	ldi TEMP1,0xFF
	adiw ZL,1               ;into next location
	rcall burnIntEep
	ldi TEMP1,0xFF
	adiw ZL,1               ;into next location
	rcall burnIntEep
	ldi TEMP1,0xFF
	adiw ZL,1               ;into next location
	rcall burnIntEep

	clt
	rcall scanNext          ;get Z=pointer to next text word in query

	tst STRINGLEN           ;Autoexe without argument
	breq AEX80

	mov YL,ZL               ;works as TIB pointer in "FindToken"
	rcall findUserToken     ;returns token value High Byte in TEMP5   26Aug23
							;and token value Low Byte in TEMP2
							;or jumps directly to QUIT if no valid token
	brtc AEX90				;UserToken not found

	mov TEMP1,TEMP5         ;Token High Byte
	ldi ZL,LOW(XAUTO)
	ldi ZH,HIGH(XAUTO)
	rcall burnIntEep
	mov TEMP1,TEMP5
	com TEMP1               ;Token High Byte Complement
	adiw ZL,1
	rcall burnIntEep
	mov TEMP1,TEMP2         ;Token Low Byte
	adiw ZL,1
	rcall burnIntEep
	mov TEMP1,TEMP2
	com TEMP1               ;Token Low Byte Complement
	adiw ZL,1
	rcall burnIntEep
	ret
AEX80:
	ret

AEX90:
;no matching string found  26Aug23
	rjmp parameterErr


VARR:   ;  ( -- ;<name> )  ******************************************
;pointer re-adjustment with  reAddressVars
;********************************************************************
	ldi TEMP2,HIGH(VARBASE)
	mov TEMP3,TEMP2			;TEMP3 cannot load immediately
	lds TEMP2,VARLOW
	tst TEMP2               ;check for overflow
	brcs VRR80              ;for this reason LOW(VARBASE) must be != 0
	rcall compileName       ;enters Variable-adddress(=TEMP2) too
	cbr AVIFLAGS,m_COMPILE

	lds ZH,USYMBHEADH      	;refill attribute
	lds ZL,USYMBHEADL
	_READ_EEPR_SYMB         ;get countByte
	mov TEMP1,r0
	sbr TEMP1,m_VARATTRIB
	rcall burnIntEep
	rjmp reAddressVars
VRR80:  
	rjmp memoryError


VARA:   ;  ( -- addr)  **********************************************
;put address of VA value on TOS
;********************************************************************
	st -X,TOSH
	st -X,TOSL				;emulate DUP
	ldi TOSH,HIGH(VA_VALUE)
	ldi TOSL,LOW(VA_VALUE)
	ret


VARB:   ;  ( -- addr)  **********************************************
;put address of VB value on TOS
;********************************************************************
	st -X,TOSH
	st -X,TOSL				;emulate DUP
	ldi TOSH,HIGH(VB_VALUE)
	ldi TOSL,LOW(VB_VALUE)
	ret


VARC:   ;  ( -- addr)  **********************************************
;put address of VC value on TOS
;********************************************************************
	st -X,TOSH
	st -X,TOSL				;emulate DUP
	ldi TOSH,HIGH(VC_VALUE)
	ldi TOSL,LOW(VC_VALUE)
	ret


CONSTT:  ; ( value -- ;name )  **************************************
;pointer re-adjustment with reAddressVars
;********************************************************************
	mov TEMP2,TOSL
	mov TEMP3,TOSH
	ld TOSL,X+
	ld TOSH,X+
	rcall checkStack        ;no compilation with invalid parameter
	rcall compileName
	cbr AVIFLAGS,m_COMPILE 	;reset
	lds ZH,USYMBHEADH       ;refill attribute
	lds ZL,USYMBHEADL
	_READ_EEPR_SYMB         ;get countByte
	mov TEMP1,r0
	sbr TEMP1,m_CONSTATTRIB
	rcall burnIntEep
	rjmp reAddressVars


RECON:  ; ( value -- ;name )  ***************************************
;re-init an existing CONST
;different behaviour when compiling or interpreting !
;********************************************************************
	clt
	rcall scanNext          ;get Z=pointer to next text word in query
	tst STRINGLEN           ;FORGET w.o. argument
	brne REC10
	jmp syntaxError
REC10:  
	mov YL,ZL               ;works as TIB pointer
	rcall findUserToken     ;returns token value (TEMP5,TEMP2)
							;and SymbolList entry address(ZH,ZL)
	brts REC20
	jmp nameError
REC20:
; Z points to offset 0 of entry to be deleted now
	_READ_EEPR_SYMB			;returns CountByte
	mov YL,r0
	sbrs YL,CONSTATTRIB
	rjmp parameterErr

	andi YL,0x0F
	inc YL					;jump over CountByte
	add ZL,YL
	clr YL
	adc ZH,YL				;now points to actual value
;until here copile=interpret

	sbrc AVIFLAGS,COMPILE
	rjmp REC40
;interpreting state: write new value into EEPROM
	mov TEMP1,TOSH         	;CONST new HighByte 
	rcall burnIntEep
	adiw ZL,1
	mov TEMP1,TOSL       	;CONST new LowByte 
	rcall burnIntEep
	rjmp DROP
REC40:
;Compile:put immediate Value-Adress on Stack and compile write EEPROM
	mov TEMP5,ZH
	mov TEMP2,ZL
	ldi ZH,HIGH(JDOLIT)		;compile CONST
	ldi ZL,LOW(JDOLIT)
	rcall compiXToken       ;compile equivalent of DOLIT
	ldi ZH,HIGH(JWRITEEPR)	;compile CONST
	ldi ZL,LOW(JWRITEEPR)
	rcall compiCall
	ret


COLON:   ;***********************************************************
;built starting from uppermost memory address
;Offset N+2   Low Byte: Code Pointer, Const. value, Var: value address
;Offset N+1   High Byte: Code Pointer, Const. value, Var: value address
;Offsets 1 to N (N=name length max 12 Bytes)
;Offset 0 flags(top Nibble) and Count (lowest Nibble)
;Symbol table in EEPROM
;COPHI/COPLO in SRAM
;********************************************************************
;COPH/COPL is handed over adjusted to next segment address

	lds TEMP3,COPHI         ;to be entered in symbol table
	lds TEMP2,COPLO

	sts STARTCOPL,TEMP2
	sts STARTCOPH,TEMP3
	lsr TEMP3
	ror TEMP2       		;transfer Token in WORD format

;continue:

compileName:    ;****************************************************
;Parameter TEMP2=token low Byte, TEMP3=token HighByte
;Return address CountByte(=USYMBHEAD)
;Offset N+2 is reserved for LowByte
;Numbers and kernel operators are no valid names
;********************************************************************
	push TEMP2
	clt
	rcall scanNext          ;get Z=pointer to next text word in query

	ldi YH,HIGH(TIB)
	mov YL,ZL
	push TEMP3
	push YL                 ;will be TIB pointer
	rcall checkNum          ;puts valid number to ZH,ZL
	brts CN90               ;error:valid number cannot ba name
	ldi ZH,HIGH(SYMBOLTABLE*2)
	ldi ZL,LOW(SYMBOLTABLE*2)

	pop YL
	push YL
	rcall findKernelToken
	brts CN90               ;error:kernel operator cannot be overwritten

	pop YL                  ;restore
	pop TEMP3
	pop TEMP2               ;destroyed in scanNext
	rcall reAddressVars     ;returns Z as Pointer to next entry, too
							;and actualizes USYMBHEAD
	mov TEMP1,STRINGLEN

	cpi TEMP1,13
	brcs CN20
	ldi TEMP1,12            ;limit to 12 Chars
CN20:
	mov TEMP4,TEMP1         ;keep in mind
							;provisional Countbyte(VAR,CONST)
	mov r25,TEMP1
	inc r25                 ;because countbyte is counted too
CN40:
	rcall burnIntEep        ;inscribes TEMP1 as countbyte
	adiw ZL,1
	ld TEMP1,Y+
	dec r25
	brne CN40
	mov TEMP1,TEMP3         ;Token, VAR Addr, CONST HighByte 
	rcall burnIntEep
	adiw ZL,1
	mov TEMP1,TEMP2         ;Token,VAR Addr,CONST LowByte 
	rcall burnIntEep
	adiw ZL,1
	ldi TEMP1,0xFF          ;mark new end of symbol table
	rcall burnIntEep
	adiw ZL,1          
	rcall burnIntEep		;double 0xFF marks new end of symbol table
	sbr AVIFLAGS,m_COMPILE 	;start code compiler
	ret
CN90:   rjmp syntaxError


reAddressVars:   ;***************************************************
;counts Variables in existing symbol table and initialises VARLOW
;Variable-memory is allocated by rising address
;Return: ZH,ZL as Pointer to end of symbol table, too
;        and entry in USYMBHEAD (addressed in bytes format)
;********************************************************************
	ldi TEMP1,LOW(VARBASE)  ;TEMP1 to be destroyed
	sts VARLOW,TEMP1

	ldi ZH,HIGH(USERSYMBTAB)
	ldi ZL,LOW(USERSYMBTAB)
	_READ_EEPR_SYMB
	com r0                  ;=0xFF ? first byte=count byte
	breq RAV80              ;symbol table empty

RAV20:
	_READ_EEPR_SYMB
	mov r25,r0
	sbrs r0,VARATTRIB
	rjmp RAV40
	lds TEMP1,VARLOW
	inc TEMP1               ;count existing VARs and accordingly
	inc TEMP1               ;adjust Variable memory pointer for compiler
	sts VARLOW,TEMP1
RAV40:
	andi r25,0x0F           ;length of name
	subi r25,(-3)           ;add 3 for: Countbyte, 2 Byte Token
	clr r0
	add ZL,r25
	adc ZH,r0

	cpi ZH,HIGH(INTEEP)
	brcc RAV90              ;overflow
	_READ_EEPR_SYMB         ;next entry
	mov r25,r0
	cpi r25,0xFF			
	brne RAV20				;cannot be end of symbol table
	adiw ZL,1
	_READ_EEPR_SYMB         ;next entry
	mov r25,r0
	cpi r25,0xFF			;double 0xFF entry marks end of symbol table
	breq RAV70
	sbiw ZL,1
	rjmp RAV20
;end of symbol table reached
RAV70:
	sbiw ZL,1
RAV80:
	sts USYMBHEADH,ZH
	sts USYMBHEADL,ZL          ;actualise
	ret

RAV90:
	rjmp memoryError


SEMIS:    ;**********************************************************
;Parameter: TEMP4= countbyte
;********************************************************************
	sbrc AVIFLAGS,COMPILE
	rjmp SEM10
	pop ZL             	;in noncompiling state restore program counter
	pop ZL			
	ret

SEM10:
	cbr AVIFLAGS,m_COMPILE	;in compiling state finish compiling
;retore numberbase, may be changed temporatily during compilation
	bst AVIFLAGS,HEXBACK
	bld AVIFLAGS,HEX

	lds CBUFLO,COPLO
	lds CBUFHI,COPHI
	lds r25,DELTACFLO        
	sub CBUFLO,r25
	lds r25,DELTACFHI
	sbc CBUFHI,r25         	;CBUFHI/LO is abs. Byte-Pointer in CBUF
	ldi ZL,0x08            	;compile opcode "ret" 
	rcall CBurn
	ldi ZL,0x95
	rcall CBurn
	rcall cbuf2Flash

;new end of symbol table already stored by COLON
;if compilation successful, update USYMBHEAD too
	rjmp reAddressVars       ;performs ret


FORGET:   ;**********************************************************
;********************************************************************
	clt
	rcall scanNext          ;get Z=pointer to next text word in query
	tst STRINGLEN           ;FORGET without argument
	brne FGT05
	jmp syntaxError

FGT05:  mov YL,ZL           ;works as TIB pointer
	rcall findUserToken     ;returns token value (TEMP5,TEMP2)
							;and SymbolList entry address(ZH,ZL)
	brts FGT10
	jmp nameError
FGT10:
; now Z points to Offset 0 of entry to be deleted
; this will become first free segment in symbol table -->= End-Mark
	ldi TEMP1,0xFF
	rcall burnIntEep
	adiw ZL,1
	rcall burnIntEep		;double 0xFF marks end of user symbol table
	rcall reAddressVars     ;aktualises USYMBHEAD too
	rcall restoreCop		;restore CodePointer
	rjmp initCbuf     		;clear forgotten code area   
;ret executed there, 

#if (CPU==168)
CODEOF:   ;***********************************************************
;********************************************************************
	clt
	rcall scanNext          ;get Z=pointer to next text word in query

	tst STRINGLEN           ;no argument
	breq CVC90

	mov YL,ZL               ;works as TIB pointer in "findUserToken"
	rcall findToken     	;returns token value High Byte in TEMP5
							;and token value Low Byte in TEMP2
							;or jumps directly to QUIT if no valid token
	brtc CVC90				;UserToken not found

	sbrc AVIFLAGS,COMPILE
	rjmp CVC10
	st -X,TOSH			;emulate DUP
	st -X,TOSL	
	mov TOSL,TEMP2
	mov TOSH,TEMP5		
	ret

CVC10:
;Compile:put immediate Value-Adress on Stack
	ldi ZH,HIGH(JDOLIT)		;compile target addr
	ldi ZL,LOW(JDOLIT)
	rcall compiXToken       ;compile equivalent of DOLIT
	ret

CVC90:
;no matching string found  26Aug23
	rjmp nameError


VCALL:   ;***********************************************************
;********************************************************************
	lds ZL,VC_VALUE
	lds ZH,VC_VALUE+1		;VC_VALUE uses little endian
	icall    
	ret
#endif

#if (CPU==3244)

pullCmdRxBuf:   ;****************************************************
;get one byte from USB Endpoint2 buffer
;if byte available (success) set T-Flag 
;  and copy eldest byte from buffer to TEMP1 
;else return T-Flag cleared
;release EP2_BUF when more than 64 bytes are free for a new USB packet
;********************************************************************
	push TEMP2
	push TEMP3
	push ZL
	push ZH
	clt
	lds ZH,USBRXTAILH
	lds ZL,USBRXTAILL
	lds TEMP2,USBRXHEADH
	lds TEMP3,USBRXHEADL
	cp TEMP3,ZL
	brne PUB10
	cp TEMP2,ZH
	brne PUB10 
	clr TEMP1
	cbr YFLAGS,m_EP2LOCK
	rjmp PUB80

PUB10:							;at least 1 byte inside the buffer
	ld TEMP1,Z+
	cpi ZH,HIGH(EP2_BUFTOP)		;buffer top must be at page end
	brne PUB20
	ldi ZH,HIGH(EP2_BUF)
	ldi ZL,LOW(EP2_BUF)
PUB20:	
	sts USBRXTAILH,ZH
	sts USBRXTAILL,ZL

;calculate fill level of EP2_BUF
;TAIL>HEAD?
	cp TEMP2,ZH				;cp USBRXHEADH,USBRXTAILH
	brcs PUB35				;HEAD absolutely <TAIL, transform to ABSOLUTE
	breq PUB30
	rjmp PUB40				;HEAD absolutely > TAIL, =normal case
PUB30:
;High Bytes equal, then compare Low Bytes
	cp TEMP3,ZL;cp USBRXHEADL,USBRXTAILL	
	brcs PUB35
	breq PUB50				;HEAD=TAIL, no need for action
	rjmp PUB40	
PUB35:
;Absolute value in cyclic buffer: add buffer size to HEAD
;because buffer always complete pages:
;	subi TEMP2,-(EP2_SIZE)
	inc TEMP2
	inc TEMP2
	inc TEMP2

PUB40:
;fill level of buffer = HEAD-TAIL
	sub TEMP3,ZL ;USBRXTAILL
	sbc TEMP2,ZH ;USBRXTAILH
	cpi TEMP2,2
	brcs PUB45
;max 256 bytes are free in buffer
;detailled compare with LowByte	
	mov TEMP2,TEMP3			;cpi mot allowed for TEMP3
	cpi TEMP2,0x50			;at least 64 bytes reserved for 2.5 FIFO packets
	brcc PUB50
PUB45:

	sbrs YFLAGS,EP2LOCK
	rjmp PUB50	
	cbr YFLAGS,m_EP2LOCK	;gets unlocked as soon as EP2_BUF contains less than (SIZE-64) bytes
							;this way EP2_BUF always can accept
							;another packet of 64 bytes without data loss
							;(similar to CTS/RTS handshake at RS-232)
							;see EP2 interrupt handler
							;block interrupts not to disturb selection of EP2
	ldi	ZH,2				;select EP2
	sts UENUM,ZH
	lds ZH,UEINTX    	
	cbr ZH,1<<RXOUTI
	sts UEINTX,ZH			;insert a small delay 
	nop						;because RXOUTI shall be cleared before FIFOCON	
	lds ZH,UEINTX		
   	cbr ZH,1<<FIFOCON   	;clear UEINTX,FIFOCON (Bit 7, FIFO Control Bit)    
   	sts UEINTX,ZH			;message that FIFO bank is free again

PUB50:
	lds ZL,LEDAUTO			;0=AUTO, else manual
	tst ZL
	brne PUB80
	ldi ZL,LEDTIME
	mov LEDCNT,ZL
#ifdef LEONARDO
	sbi PORTD,TXLED
#else
	cbi PORTD,LED         	;GREEN LED on PCB OFF
#endif
	set

PUB80:
;this delay may be inserted to test EP2LOCK behaviour
;	rcall delay50ms
;	rcall delay50ms	
;	rcall delay50ms
;	rcall delay50ms
;	rcall delay50ms
	pop ZH
	pop ZL
	pop TEMP3
	pop TEMP2
	ret

#else

pullCmdRxBuf:  ;( -- ) **********************************************
;overwrites and returns TEMP1 and sets T-flag if succes
;********************************************************************
;check command-RX buffer
	push ZL
	push ZH
	lds ZL,CMDRXTAILL
	lds ZH,CMDRXHEADL
	cp ZH,ZL
	breq PRX80
	ldi ZH,HIGH(CMDRXBUF)
	ld TEMP1,Z+
PRX10:  
	sts CMDRXTAILL,ZL		;atomatic query tail wrap around(bufferSize=256)
	lds ZL,LEDAUTO			;0=AUTO, else manual
	tst ZL
	brne PRX20
	ldi ZL,LEDTIME
	mov LEDCNT,ZL
#ifdef LEONARDO
	sbi PORTD,TXLED         ;switch LED on again
#else
  #if ((CPU==644) || (CPU==1284) || (CPU==32))
	cbi PORTB,LED           ;switch LED on again
  #else
	cbi PORTD,LED           ;switch LED on again
  #endif
#endif
PRX20:
	set
	pop ZH
	pop ZL
	ret
PRX80:
	clt
	clr TEMP1
	pop ZH
	pop ZL
	ret
#endif


sendSPACE:  ;********************************************************
	push r24
	ldi r24,SPACE
	rjmp SCR10

sendCRR:  ;**********************************************************
	push r24
	ldi r24,CRR
SCR10:
	rcall sendCmdByte
	pop r24
	ret


#if (CPU==3244)
sendCmdByte:   ;*****************************************************
;transmit 1 byte via USB interface 
;Parameter=r24 ,non destructive
;********************************************************************
	sbrc YFLAGS,BAKDOTS
	rjmp SCB30
	nop
	nop
	push r25	
	push XL
	push XH

;check buffer fill state, loop until free memory
SCB10:
	wdr
	sbrs YFLAGS,EP1TRIGGER
	rjmp SCB20				;buffer is empty, continue
	lds XL,EP1_HEAD
	lds r25,EP1_TAIL
	sub XL,r25
	cpi XL,16  ;60
	brcc SCB10				

;enough buffer space available, add new byte
SCB20:
	nop
	cbr YFLAGS,m_EP1TRIGGER ;avoid break_in by interrupt

;fill byte into buffer, buffer is not cyclic
	ldi XH,HIGH(EP1_BUF)
	lds XL,EP1_HEAD			;overflow impossible
	st X+,r24
	sts EP1_HEAD,XL
	cpi XH,HIGH(EP1_BUFTOP)
	brne SCB25
	ldi XH,HIGH(EP1_BUF)
SCB25:
	sbr YFLAGS,m_EP1TRIGGER
	pop XH
	pop XL
	pop r25
	ret	


;*************************
;transmit 1 byte via USB interface without interrupt
;*************************
SCB30:
	push r25	
	nop
	ldi	r25,1				;select EP1
	sts UENUM,r25

;check if TXINI is set or wait for this event
SCB40:
	wdr
    lds  r25,UEINTX      	;check if buffer is free for new data
    sbrs r25,TXINI      	;wait until TXINI(bit0) is set
    rjmp SCB40          	;(see manual 22.14.1 p.275))
 	
  	lds  r25,UEINTX   	
    cbr r25,1<<TXINI|1<<NAKINI  ;clear event messaging flags
    sts UEINTX,r25
	sts UEDATX,r24			;transmit
	nop							;because TXINI shall be cleared before FIFOCON
    lds r25,UEINTX      	;(bit7, FIFO Control Bit)
    cbr r25,1<<FIFOCON   	;clearing of FIFOCON (bit7) triggers data transmission
    sts UEINTX,r25
	pop r25
	ret	

#else

sendCmdByte:   ;*****************************************************
; send one byte .
; Parameter=r24, non destructive
;********************************************************************
  #if (CPU==32)
SCB10:
	sbis UCSRA,UDRE
	rjmp SCB10
	out UDR,r24
	ret
  #else
	push r25
SCB10:
	lds r25,UCSR0A
	sbrs r25,UDRE0
	rjmp SCB10
	sts UDR0,r24
	pop r25
	ret
  #endif

#endif ;CPU3244 or not


sendASCII:   ;*******************************************************
;send value of one byte in ASCII readable text.
;Parameter=r24, non destructive!
;********************************************************************
	push r24
	ldi r24,SPACE
	sbrs AVIFLAGS,NOLEADS    ;suppress leading space
	rcall sendCmdByte
	pop r24
#if (CPU==3244)
	tst r24
	brne SAS10
	sbrs XFLAGS,LEADZERO
	rjmp SAS10
	ldi r24,'0'
	rcall sendCmdByte
	rcall sendCmdByte
	ret
SAS10:
#endif
	push r24                ;copy stack
	swap r24
	andi r24,0x0F
	subi r24,0xD0           ;add 0x30
	cpi r24,0x3A
	brcs SAS30
	subi r24,0xF9           ;add 7
SAS30: 
#if (CPU==3244)  
	cpi r24,'0'
	brne SAS60
	sbrc AVIFLAGS,NOLEADS
	rjmp SAS40
	ldi r24,SPACE			;suppress leading zero
	rjmp SAS60
SAS40:
	sbrs XFLAGS,LEADZERO
	rjmp SAS70
	ldi r24,'0'
#else
	cpi r24,'0'
	brne SAS60
	sbrc AVIFLAGS,NOLEADS
	rjmp SAS70
	ldi r24,SPACE			;suppress leading zero
#endif
SAS60:   
	rcall sendCmdByte	    ;send High-Nibble first
SAS70:   
	pop r24
	push r24                ;copy stack
	andi r24,0x0F
	subi r24,0xD0           ;add 0x30
	cpi r24,0x3A
	brcs SAS80
	subi r24,0xF9           ;add 7
SAS80:   
	rcall sendCmdByte  		;send Low-Nibble last
	pop r24
	ret


sendWord:   ;*******************************************************
;send value of one WORD in ASCII readable text.
;Parameter: r24= LowByte ! r25=HighByte ! AVIFLAGS,m_TEMPHEX and m_NOLEADS
;			TEMP5: 0->signed, else unsigned
;output number base is locally conformant with TEMPHEX
;*******************************************************************
	rcall sendSPACE			;leaves r24 unmodified

narrowSendWord:   ;********************
	push TEMP1
	push TEMP2
	push TEMP3
	push TEMP4
	push r25
	push ZL
	push ZH
	st -X,TOSH				;emulate DUP
	st -X,TOSL
	clr TEMP2               ;counter for written number characters
	clr TOSH
	ldi ZH,HIGH(PAD)
	ldi ZL,LOW(PAD)         ;pointer to number mounting buffer

	sbrc AVIFLAGS,NOLEADS
	rjmp SWD05
	rcall sendSPACE			;r24,r25 unmodified
SWD05:

;system hex number base active
	sbrs AVIFLAGS,TEMPHEX	;temporary number base overrides system numBase
	rjmp SWD10				;no temp.hex, print decimal			
;all decimal options excluded, print hex
;hex numbers always printed unsigned
	ldi TOSL,0x10
	push r24
	ldi r24,'0'
	rcall sendCmdByte
	ldi r24,'x'
	rcall sendCmdByte
	pop r24
	rjmp SWD20
SWD10:
;decimal number base aktive
	ldi TOSL,10             ;Divisor
SWD20:
	tst TEMP5
	brne SWD30				;send unsigned
; sign handling
	sbrs r25,7              ;skip if negative number
	rjmp SWD30
;is a 16 bit negative number
	ldi TEMP2,0x80          ;use as neg. Flag
	push r24
	ldi r24,'-'
	rcall sendCmdByte
	pop r24

	com r24
	com r25
	adiw r24,1              ;16 bit two's complement
SWD30:
;divide out
	rcall DIVsub			;doesn't change TMEP2 nor TEMP5
	inc TEMP2
	mov TEMP1,TEMP3
	andi TEMP1,0x0F          ;--> numToChar
	subi TEMP1,0xD0          ;add 0x30
	cpi TEMP1,0x3A
	brcs SWD40
	subi TEMP1,0xF9        	;add 7
SWD40:  
	st Z+,TEMP1       		;into PAD
	tst r25                 ;Check if result zero
	brne SWD30
	tst r24
	brne SWD30
;ready
	mov r25,ZL
	subi r25,LOW(PAD)       ;number of chars PAD
SWD90:
	ld r24,-Z
	rcall sendCmdByte
	dec r25
	brne SWD90

	pop ZH
	pop ZL
	pop r25
	pop TEMP4
	pop TEMP3
	pop TEMP2
	pop TEMP1
	ld TOSL,X+				;emulate DROP
	ld TOSH,X+		
	ret 


sendString:       ;**************************************************
;send null terminated string from Flash range r25,r24
;Parameter: r24= start address Low, r25= start address High
;Pointer to first byte in Flash Memory. r24 gets destroyed/overwritten
;********************************************************************
	push r0
	push r24
	push ZH
	push ZL
	mov ZH,r25        
	mov ZL,r24
	rjmp SS10


pageSendString:   ;**************************************************
;send null terminated string from Flash range HISTRING
;Parameter: r24= start address Low, start address High is fixed to one page
;Pointer to first byte in Flash Memory. r24 gets destroyed/overwritten
;********************************************************************
	push r0
	push r24
	push ZH
	push ZL
	ldi ZH,HIGH(HISTRING*2)        
	mov ZL,r24
SS10:
	rcall delay200us			;at high baudrate PC terminal buffer may overflow
	rcall delay200us
	rcall delay200us
	rcall delay200us
	rcall delay200us
	rcall delay200us
	lpm
	tst r0
	breq SS80
	mov r24,r0
	rcall sendCmdByte
	adiw ZL,1
	rjmp SS10
SS80:   
	pop ZL
	pop ZH
	pop r24
	pop r0
#if (CPU==3244)
	nop
	nop
#endif
	ret

delay:    ;**********************************************************
;ca 5us  (valid for 16MHz CPU clock)
;********************************************************************
#if (CPU==3244)
	push r25
#endif
	ldi r25,5
	rjmp usDelay

delay200us:   ;******************************************************
;delay ca.200 mikroseconds
;********************************************************************
#if (CPU==3244)
	push r25
#endif
  #ifdef SPEED_18M
	ldi r25,225 
  #endif   
   #ifdef SPEED_16M
	ldi r25,200   
  #endif       	
  #ifdef SPEED_14M
	ldi r25,175   
  #endif
  #ifdef SPEED_11M
	ldi r25,132
  #endif
  #ifdef SPEED_7M
  	ldi r25,88
 	sbrs XFLAGS,HISPEED
	ldi r25,11				;operates with 921kHz
  #endif
  #ifdef SPEED_1M8
 	ldi r25,22 
	sbrs XFLAGS,HISPEED
	ldi r25,11				;operates with 921kHz
  #endif  									
 
usDelay:  ;**************	;MUST BE JUMPED INTO WITH r25 PUSHED and loaded!
							;basic duration/loop = 16 clock cycles 
							;except call and return
	tst r25					;1 cycle
	breq DDL80              ;1 cycle if condition is false
	push r25				;2 cycles
	pop	r25					;2 cycles
	push r25				;2 cycles
	pop	r25					;2 cycles
	push r25				;2 cycles
	pop	r25					;2 cycles
	dec r25					;1 cycle
	rjmp usDelay				;2 cycles		
DDL80:
#if (CPU==3244)
	pop r25
#endif
	ret

parameterErr:   ;****************************************************
;********************************************************************
	ldi r25,m_PARAMERR
	rjmp QUIT           

memoryError:   ;*****************************************************
	ldi r25,m_MEMERR
	rjmp QUIT           


runTimeErr:  ;*******************************************************
	ldi r25,m_RUNERR        ;mark runtime error
	rjmp QUIT           


nameError:    ;******************************************************
;********************************************************************
	ldi r25,m_STRTOKERR
	rjmp QUIT


syntaxError:    ;**************************************************
;********************************************************************
	ldi r25,m_SYNTXERR
	rjmp QUIT


#if ((CPU==644) || (CPU==1284) || (CPU==3244))
NOBAK:  ;  ( T|F -- )  **********************************************
;TRUE deactivates ABORT when ESC is sent via terminal
;by default, ESC option is active
;********************************************************************
	cbr XFLAGS,m_NOBACKGND
	or TOSL,TOSH
	tst TOSL
	breq NBK10
	sbr XFLAGS,m_NOBACKGND
NBK10:
	rjmp DROP			
#endif


#if (CPU == 168)
#ifdef SPEED_7M
SPEED:  ; ( 1|2 --  )  ***********************************************
;change system speed during runtime
;before use: insert a 1ms pause to finish any USART transmission(if active)
;*********************************************************************
	cpi TOSL,2
	brcc SPD10
;switch down to 921kHz clock
	ldi r24,0x80			
	ldi r25,3				;2 step clock prescaler init procedure
	sts CLKPR,r24			;only write CLKPCE bit
	sts CLKPR,r25			;set division/8
	cbr XFLAGS,m_HISPEED
	rjmp SPD80
SPD10:
;switch up to 7.37MHz clock;
	ldi r24,0x80			
	clr r25					;2 step clock prescaler init procedure
	sts CLKPR,r24			;only write CLKPCE bit
	sts CLKPR,r25			;set division/1 (CPU clock = crystal freq)
	sbr XFLAGS,m_HISPEED
SPD80:
	call initUSART0
	rjmp DROP
#endif

#ifdef SPEED_1M8
SPEED:  ; ( 1|2 --  )  ***********************************************
;change system speed during runtime
;before use: insert a 1ms pause to finish any USART transmission(if active)
;*********************************************************************
	cpi TOSL,2
	brcc SPD10
;switch down to 921kHz clock
	ldi r24,0x80			
	ldi r25,1				;2 step clock prescaler init procedure
	sts CLKPR,r24			;only write CLKPCE bit
	sts CLKPR,r25			;set division/2
	cbr XFLAGS,m_HISPEED
	rjmp SPD80
SPD10:
;switch up to 1.8432MHz clock;
	ldi r24,0x80			
	clr r25					;2 step clock prescaler init procedure
	sts CLKPR,r24			;only write CLKPCE bit
	sts CLKPR,r25			;set division/1 (CPU clock = crystal freq)
	sbr XFLAGS,m_HISPEED
SPD80:
	call initUSART0
	rjmp DROP
#endif
#endif ;(CPU == 168)


MEM:  ;  ( -- )  ***************************************************
;S=free symbol table/8, C=free blocks of Code, V=free number of Variables
;TOS=0: short version, show user available space of memories
;		else add content of compiler relevant memories
;********************************************************************
	push AVIFLAGS
	cbr AVIFLAGS,m_NOLEADS
	rcall sendCRR

	tst TOSH
	breq MEM05

;simple flash page display
	sbr AVIFLAGS,m_TEMPHEX 	;f hex, then always preface 0x
	rcall sendCRR
	ldi r24,LOW(pageString*2) 
	ldi r25,HIGH(pageString*2) 
	rcall sendString
	lsl TOSL				;lpm needs address in bytes
	rol TOSH			
	andi TOSL,0xF0			;smooth start address down
	mov r24,TOSL
	mov r25,TOSH
	rcall listFlashPage
	jmp MEM90	

MEM05:
	tst TOSL
	brne MEM10

#if (CPU==3244)
	ldi r24,LOW(decimalString*2) 
	ldi r25,HIGH(decimalString*2) 
	rcall sendString
#else
	ldi r24,LOW(DECIMALSTR*2)
	rcall pageSendString
#endif
	lds ZH,USYMBHEADH
	lds ZL,USYMBHEADL
	ldi r25,HIGH(INTEEP)
	ldi r24,LOW(INTEEP)
	sub r24,ZL
	sbc r25,ZH
	lsr r25					;message in WORDS
	ror r24

	sbr AVIFLAGS,m_NOLEADS
	cbr AVIFLAGS,m_TEMPHEX 	;return memory sizes decimal values
	rcall narrowSendWord
	rcall sendSPACE
	ldi r24,'C'
	rcall sendCmdByte
	ldi r24,':'
	rcall sendCmdByte

	lds ZL,COPLO
	lds ZH,COPHI            ;bytes
	lsr ZH
	ror ZL                  ;words
	ldi r25,HIGH(USERFLASH)
	ldi r24,LOW(USERFLASH)	;words, too
	sub r24,ZL
	sbc r25,ZH	
	clr TEMP5				;send signed word
#if(CPU==1284)
	inc TEMP5				;send unsigned
#endif
	rcall narrowSendWord	;message in WORDS
	ldi r24,SPACE
	rcall sendCmdByte
	rcall sendCmdByte
	ldi r24,'V'
	rcall sendCmdByte
	ldi r24,':'
	rcall sendCmdByte
	ldi r24,LOW(VARTOP)
	lds r25,VARLOW
	sub r24,r25
	lsr r24					;message in WORDS
	clr r25
	rcall narrowSendWord
	cbr AVIFLAGS,m_NOLEADS
	jmp MEM90

;from here on debug version:
MEM10:	
	sbr AVIFLAGS,m_TEMPHEX 	;f hex, then always preface 0x
	push r0
	push ZL
	push ZH
#if (CPU==3244)
	ldi r24,LOW(userString*2) 
	ldi r25,HIGH(userString*2) 
	rcall sendString
#else
	ldi r24,LOW(EEPROMSTR*2)
	rcall pageSendString
#endif
	rcall byteColumn
;look for top of symbol table
;if high, start from appropriate offset
	ldi ZH,HIGH(USERSYMBTAB)
	ldi ZL,LOW(USERSYMBTAB)
MEM20:
	_READ_EEPR_SYMB
	adiw ZL,1
	mov r25,r0
	cpi r25,0xFF
	brne MEM20
	_READ_EEPR_SYMB
	mov r25,r0
	cpi r25,0xFF		;end of User Symbol Table marked by double 0xFF
	brne MEM20
	tst ZH
	breq MEM30
	adiw ZL,0x10
	andi ZL,0xF0		;round up to next zero least nibble	
	dec ZH
	rjmp MEM35
MEM30:
	ldi ZH,HIGH(USERSYMBTAB)
	ldi ZL,LOW(USERSYMBTAB)
MEM35:
	ldi r25,255
MEM40:
	rcall sendCRR
	push r25
	tst ZH
	brne MEM45
	rcall sendSPACE
MEM45:
	mov r24,ZL
	mov r25,ZH
	rcall sendWord
	ldi r24,':'
	rcall sendCmdByte
	pop r25
MEM50:
	wdr
	_READ_EEPR_SYMB
	adiw ZL,1
	mov r24,r0
	rcall sendASCII
	cpi r24,0xFF
	brne MEM55
	_READ_EEPR_SYMB
	mov r24,r0
	cpi r24,0xFF
	brne MEM55
	rcall sendASCII
	ldi r25,1
	rjmp MEM60				;end of User Symbol Table marked by double 0xFF
MEM55:
	mov r24,ZL
	andi r24,0x0F
	breq MEM40
	cpi r24,8
	brne MEM60
	rcall sendSPACE			;doesn't change value of r24
MEM60:
	dec r25
	brne MEM50

	mov r24,PAGEHI
	cpi r25,HIGH(KERNELTOP)
	brne MEM65
	tst PAGELO
	breq MEM80
MEM65:
	ldi r24,LOW(previousString*2) 
	ldi r25,HIGH(previousString*2) 
	rcall sendString
	ldi r24,LOW(pageString*2) 
	ldi r25,HIGH(pageString*2) 
	rcall sendString
;send previously programmed flash page
	mov r24,PAGELO
	mov r25,PAGEHI
#if (FLASHPAGE==128)
	 dec r25
#else
	tst r24
	breq MEM70
	subi r24,0x80
	rjmp MEM75
MEM70:
	dec r25
	ldi r24,0x80
MEM75:
#endif
	rcall listFlashPage

MEM80:
	ldi r24,LOW(actualString*2) 
	ldi r25,HIGH(actualString*2) 
	rcall sendString
	ldi r24,LOW(pageString*2) 
	ldi r25,HIGH(pageString*2) 
	rcall sendString
;send actually programmed flash page
	mov r24,PAGELO
	mov r25,PAGEHI
	rcall listFlashPage
	pop ZH
	pop ZL
	pop r0
	rcall listCbuf
MEM90:
	pop AVIFLAGS
	rjmp DROP


listFlashPage:   ; **************************************************
;send 128 or 256 bytes Flash  (parameter first address r25,r24) via terminal
; *******************************************************************
	push ZL
	push ZH
	mov ZL,r24					;lpm needs address in bytes
	mov ZH,r25
	rcall wordColumn
	rcall lineNumber
#if (FLASHPAGE==128)
	ldi r25,255
#else
	ldi r25,127
#endif


LIF10:
#if (CPU==3244)
	rcall delay200us
	rcall delay200us
#endif
	wdr
	lpm r24,Z+
	rcall sendASCII
	mov r24,r25
	andi r24,0x0F
	tst r24
	breq LIF20
	rjmp LIF30
LIF20:
	rcall lineNumber
LIF30:
	cpi r24,8
	brne LIF40
	rcall sendSPACE			;doesn't change value of r24
LIF40:
	dec r25
	tst r25
	brne LIF10
	push r25
	lpm r24,Z+
	rcall sendASCII
	pop r25
	tst r25
	brne LIF10

	pop ZH
	pop ZL
	ret


lineNumber:  ;*******************************************************
;********************************************************************
	rcall sendCRR
	push r25
	mov r25,ZH
	mov r24,ZL
	lsr r25
	ror r24
	rcall narrowSendWord
	ldi r24,':'
	call sendCmdByte
	pop r25	
	ret

wordColumn:     ;****************************************************
;********************************************************************
	ldi r25,0xF7
COL10:
	rcall sendSPACE
	inc r25
	cpi r25,10
	brcc COL10
	mov r24,r25
	ori r24,0x30
	rcall sendCmdByte
	ldi r24,'/'
	rcall sendCmdByte
	mov r24,r25
	ori r24,0x38
	cpi r24,0x3A
	brcs COL20
	subi r24,-7
COL20:
	rcall sendCmdByte
	rcall sendSPACE
	rcall sendSPACE
	cpi r25,3
	brne COL30
	rcall sendSPACE
COL30:
	cpi r25,7
	brcs COL10
	ret


byteColumn:     ;****************************************************
;********************************************************************
	ldi r25,0xFE
BCL10:
	rcall sendSPACE
	inc r25
	cpi r25,20
	brcc BCL10
	mov r24,r25
	ori r24,0x30
	cpi r24,0x3A
	brcs BCL20
	subi r24,-7
BCL20:
	rcall sendCmdByte
	rcall sendSPACE
	cpi r25,7
	brne BCL30
	rcall sendSPACE
BCL30:
	cpi r25,15
	brcs BCL10
	ret


listCBuf:   ;********************************************************
;parameters; r24=PAGELO,, r25=PAGEHI
;********************************************************************
	push AVIFLAGS
	sbr AVIFLAGS,m_TEMPHEX
	push r24
	push r25
	push ZL
	push ZH
#if (CPU==3244)
	ldi r24,LOW(cbufString*2) 
	ldi r25,HIGH(cbufString*2) 
	rcall sendString
#else
	ldi r24,LOW(CBUFSTR*2)
	rcall pageSendString
#endif
	ldi ZL,LOW(CBUF)
	ldi ZH,HIGH(CBUF)
	push r25
	mov r25,ZH
	mov r24,ZL
	rcall narrowSendWord
	ldi r24,':'
	rcall sendCmdByte
	pop r25	
#if (FLASHPAGE==128)
	ldi r25,255
#else
	ldi r25,127
#endif
LCB10:
#if (CPU==3244)
	rcall delay 
	rcall delay200us
#endif
	wdr
	ld r24,Z+
	rcall sendASCII
	mov r24,r25
	andi r24,0x0F
	cpi r24,8
	brne LCB20
	rcall sendSPACE
LCB20:
	tst r24
	breq LCB30
	rjmp LCB40
LCB30:
#if (FLASHPAGE==128)
	cpi ZH,HIGH(CBUF)+1
	brcc LCB80
#else
	cpi ZL,0x80
	brcc LCB80
#endif
	rcall sendCRR
	push r25
	mov r25,ZH
	mov r24,ZL
	rcall narrowSendWord
	ldi r24,':'
	rcall sendCmdByte
	pop r25	
LCB40:
	dec r25
	rjmp LCB10

LCB80:
	rcall sendCRR
	pop ZH
	pop ZL
	pop r25
	pop r24
	pop AVIFLAGS
	ret
#if (CPU==3244)
userString:
	.DB CRR,"EEPROM:",0,0

cbufString:
	.DB CRR,"temp.SRAM:",CRR,0,0

decimalString:
	.DB "(decimalWORDS) S:",0
#endif
pageString:
	.DB " page (WORD addr):",CRR,0

previousString:
	.DB CRR,"previous",0

actualString:
	.DB CRR,"actual",0


DOTS:  ;  ( -- )  ***************************************************
;send upper content of data stack plus actual values of some Variables
;********************************************************************
	rcall sendCRR
	push AVIFLAGS
	sbr AVIFLAGS,m_NOLEADS
	cbr AVIFLAGS,m_TEMPHEX    
	sbrc AVIFLAGS,HEX
	sbr AVIFLAGS,m_TEMPHEX    	;if hex, then always send leading 0x

	ldi TEMP1,LOW(DATASTACK)
	cp XL,TEMP1  
	brcs DTS20      
	breq DTS10
	rcall stackErrMsg
	rjmp DTS50
DTS10:  
	rcall sendSPACE
	ldi r24,'-'
	call sendCmdByte
	rcall sendSPACE
	rjmp DTS50
DTS20:  
	subi TEMP1,2            	;(DATASTACK-2)
	cp XL,TEMP1
	breq DTS40
	mov ZL,TEMP1
	ldi ZH,HIGH(DATASTACK)
DTS30:  
	ld r25,-Z					;High Byte
	ld r24,-Z					;Low Byte
	rcall sendWord
	rcall sendSPACE
	cp ZL,XL
	breq DTS40
	brcc DTS30					;inserted 04JUL23
DTS40:  
	mov r24,TOSL
	mov r25,TOSH
	rcall sendWord
	rcall sendSPACE
DTS50:
	ldi r24,LOW(TOSSTR*2)         
	rcall pageSendString
	ldi ZH,HIGH(VA_VALUE)       
	ldi ZL,LOW(VA_VALUE)
	rcall dump3
	call sendCRR
	ldi r24,LOW(VARSTR*2)
	rcall pageSendString
	ldi ZH,HIGH(VARBASE)       
	ldi ZL,LOW(VARBASE)
	rcall dump4
	rcall dump4
	ldi r24,CRR
	call sendCmdByte
	pop AVIFLAGS
	ret

dump3:
;display values of 3 kernel based variables VA,VB,VC
	ld r24,Z+               	;Low Byte
	ld r25,Z+               	;High Byte
	rcall narrowSendWord
	rcall sendSPACE
	rcall sendSPACE
	ldi r24,'V'
	rcall sendCmdByte
	ldi r24,'B'
	rcall sendCmdByte
	ldi r24,':'
	rcall sendCmdByte
	ld r24,Z+               	;Low Byte
	ld r25,Z+               	;High Byte
	rcall narrowSendWord
	rcall sendSPACE
	rcall sendSPACE
	ldi r24,'V'
	rcall sendCmdByte
	ldi r24,'C'
	rcall sendCmdByte
	ldi r24,':'
	rcall sendCmdByte
	ld r24,Z+               	;Low Byte
	ld r25,Z+               	;High Byte
	rcall narrowSendWord
	ret

dump4:
;display 4 variables (by increasing index = increasing phys. address)
	rcall sendSPACE
	ldi r25,4
DMP10:
	push r25
	ld r24,Z+               	;Low Byte
	ld r25,Z+               	;High Byte
	rcall narrowSendWord
	rcall sendSPACE
	pop r25
	dec r25
	brne DMP10
	rcall sendSPACE
	ret


KERNELOPS:   ;*******************************************************
;********************************************************************
;Kernel-Primaries, type independent
	ldi r24,LOW(KERNELSTR*2)       
	rcall pageSendString

	ldi ZH,HIGH(SYMBOLTABLE*2)
	ldi ZL,LOW(SYMBOLTABLE*2)
	rcall listKernelSymbols
	ret


listKernelSymbols:   ;***********************************************
;********************************************************************
LKS10:  
	ldi r25,7
LKS20:  
	wdr
	push r25
	rcall nextKernelToken
	pop r25
	brtc LKS80
	dec r25
	brne LKS20
	ldi r24,CRR
	call sendCmdByte
	wdr
	rjmp LKS10
LKS80:
	ret


nextKernelToken:    ;************************************************
;get pointer to name string from token value,return string via console
;Parameter ZL,ZH current pointer to symbol table
;T=finish flag
;separate routines for Kernel and User symbol tabelle
;********************************************************************
	lpm
;first check valid range
	mov r25,r0
	cpi r25,0xFF
	brne NKT10              ;0xFF count is end of list
	clt                     ;mark this
	ret

NKT10:
	mov TEMP1,r0            ;get count byte
	mov TEMP3,TEMP1         ;merken 
	andi TEMP1,0x0F         ;kill flags
	mov r25,TEMP1
	neg r25
;printout handler
	adiw ZL,1               ;first character of string
;print string
NKT20:
	lpm r24,Z+
	call sendCmdByte
	dec TEMP1
	brne NKT20
;don't print token value
	rcall sendSPACE         ;leading space to align printout colums
NKT25:
	subi r25,0xF6           ;calculate fill spaces
NKT30:  
	rcall sendSPACE
	dec r25
	brne NKT30
	set
	adiw ZL,4
	sbrc TEMP3,0         
	rjmp NKT35              ;jmp if gerade Namen-Lnge= unger.Eintr.Lnge
	adiw ZL,1               ;wg. AVRA eingef. Nullbyte  berspringen
NKT35:  
	ret


DOTRS:  ;  ( -- )  **************************************************
;send upper content of data stack plus actual values of some Variables
;********************************************************************
	rcall sendSPACE
	ldi r24,'R'
	rcall sendCmdByte
	ldi r24,'S'
	rcall sendCmdByte
	ldi r24,':'
	rcall sendCmdByte

	pop TEMP2			;return address of .RS
	pop TEMP1
	pop TEMP4		
	pop TEMP3
	pop ZH
	pop ZL
	pop r1
	pop r0
	pop r25
	pop r24

	push r24
	push r25
	push r0
	push r1
	push ZL
	push ZH
	push TEMP3
	push TEMP4
	push TEMP1
	push TEMP2

	push AVIFLAGS
	sbr AVIFLAGS,m_TEMPHEX | m_NOLEADS
	push r25
	push r24
	mov r25,TEMP4
	mov r24,TEMP3
	rcall narrowSendWord	;saves TEMP1,2,3,4, ZH/L, r25
	mov r25,ZH
	mov r24,ZL
	rcall sendWord
	mov r25,r1
	mov r24,r0
	rcall sendWord
	pop r24
	pop r25
	rcall sendWord

	rcall sendSPACE
	rcall sendSPACE
	ldi r24,'P'
	rcall sendCmdByte
	ldi r24,'C'
	rcall sendCmdByte
	ldi r24,':'
	rcall sendCmdByte

	mov ZH,TEMP2
	mov ZL,TEMP1
	sbiw ZL,2
	lsl ZL
	rol ZH				;word->byte addr
	lpm r24,Z+
	lpm r25,Z+
	lsr ZH		
	ror ZL				;byte->increased word addr

	cpi r25,0x94		;check if call or rcall to .RS ?
	brne DRS10			
	cpi r24,0x0E	
	brne DRS10
	sbiw ZL,1
DRS10:
	mov r25,ZH
	mov r24,ZL
	rcall narrowSendWord ;PC before .RS call/rcall
	rcall sendCRR
	pop AVIFLAGS

	ret



USEROPS:   ;*********************************************************
;********************************************************************
	ldi r24,CRR
	rcall sendCmdByte 
;check first if User entries exist
	ldi ZH,HIGH(USERSYMBTAB)
	ldi ZL,LOW(USERSYMBTAB)
	_READ_EEPR_SYMB
	com r0                  ;if empty, then=0xFF
	breq UPS20              ;user list empty
;user list not empty
	rcall listUserSymbols   ;old entries first
	ret

UPS20: 
;user list empty
	ldi r24,LOW(noUserString*2) 
	ldi r25,HIGH(noUserString*2) 
	rcall sendString
	ret


NoUserString:
	.DB "-none-",CRR,0


listUserSymbols:   ;*************************************************
;Parameter: ZH signals from which memory range is read first
;send old entries first
;********************************************************************
	push AVIFLAGS
	sbr AVIFLAGS,m_TEMPHEX | m_NOLEADS
	ldi ZH,HIGH(USERSYMBTAB)
	ldi ZL,LOW(USERSYMBTAB)
;test for empty table has alreay been made
	ldi r25,4
LUS10:  
	wdr
	push r25
	_READ_EEPR_SYMB
	adiw ZL,1
	mov TEMP1,r0
	mov TEMP2,r0
     ;   push r0
	andi TEMP1,0x0F         ;length of name
	mov r25,TEMP1
	neg r25
LUS20:
;printout handler
	_READ_EEPR_SYMB
	adiw ZL,1
	mov r24,r0
	call sendCmdByte
	dec TEMP1
	brne LUS20
;print token value
	rcall sendSPACE
	ldi r24,'='
	call sendCmdByte

	cbr AVIFLAGS,m_TEMPHEX
	sbrc AVIFLAGS,HEX
	sbr AVIFLAGS,m_TEMPHEX  	;if hex, then always preceeding 0x

	ldi r24,SPACE	
	sbrs TEMP2,CONSTATTRIB
	rjmp LUS25
	ldi r24,'#'
	rjmp LUS40
LUS25:
	sbrs TEMP2,VARATTRIB
	rjmp LUS30
	ldi r24,'@'
	call sendCmdByte
LUS30:
	sbr AVIFLAGS,m_TEMPHEX		;special case: flash addresses always hex
LUS40:  
	_READ_EEPR_SYMB
	mov r1,r0
	adiw ZL,1
	_READ_EEPR_SYMB
	adiw ZL,1

;print value in active number base
	push r25
	mov r25,r1
	mov r24,r0
	rcall narrowSendWord
	pop r25
	cbr AVIFLAGS,m_TEMPHEX
	sbrc AVIFLAGS,HEX
	sbr AVIFLAGS,m_TEMPHEX  	;if hex, then always preceeding 0x
	sbrs TEMP2,VARATTRIB
	rjmp LUS50
	ldi r24,'#'
	call sendCmdByte

	push ZL
	push ZH
	push r25
	mov ZH,r1
	mov ZL,r0
	ld r24,Z+
	ld r25,Z
	rcall narrowSendWord
	pop r25
	pop ZH
	pop ZL

LUS50:  
	subi r25,0xF8           ;calculate fill spaces
	brcs LUS60
	cpi r25,2
	brcc LUS70
LUS60:
	ldi r25,2
LUS70:  
	rcall sendSPACE
	dec r25
	brne LUS70
;next entry of symbol table is continued directly here
	cpi ZH,HIGH(INTEEP)
	brcc LUS90              ;overflow
	_READ_EEPR_SYMB
	pop r25                 ;columns counter
	mov TEMP2,r0
	cpi TEMP2,0xFF
	breq LUS80
	dec r25
	brne LUS75
	call sendCRR
	ldi r25,4
LUS75:  
	rjmp LUS10

LUS80:  
;End of symbol table reached
	pop AVIFLAGS
	ret

LUS90:
	rjmp memoryError


SEE:   ; ( -- ) *****************************************************
;********************************************************************
	push AVIFLAGS
	cbr AVIFLAGS,m_TEMPHEX
	sbrc AVIFLAGS,HEX
	sbr AVIFLAGS,m_TEMPHEX	;necessary for sendWord

	clt
	rcall scanNext         	;get kernel op/user thread to be SEEn
	;        				;returns:ZL = actual STRSTART
	tst STRINGLEN          	;SEE without argument
	brne SEE02
	jmp syntaxError

SEE02:  
	mov YL,ZL       		;works as TIB pointer in "findUserToken"
	rcall findUserToken  	;returns token High@TEMP5, Low@TEMP2
	brts SEE05
	jmp nameError           ;not found

SEE05:
	mov r24,TEMP5			;direct check of TEMP5 impossible by machine code
	cpi r24,HIGH(KERNELTOP)	;can't SEE kernel functions
	brcc SEE10
	jmp parameterErr

SEE10:
;first return symbol table entry
;Parameter Z = pointer to count byte in EEPROM
#if (CPU==3244)
	ldi r24,LOW(userString*2) 
	ldi r25,HIGH(userString*2) 
	rcall sendString
#else
	ldi r24,LOW(EEPROMSTR*2)
	rcall pageSendString
#endif
	mov r25,ZH
	mov r24,ZL
	rcall narrowSendWord			;send address of count byte	
	rcall sendCRR

;token = code address WORD formatted
	mov YH,TEMP5
	mov YL,TEMP2

	sbr AVIFLAGS,m_NOLEADS
;from here loop for printout of code content:
	ldi ZH,5                ;positions per line
SEE15:  
	push ZH
	wdr
	rcall sendSPACE
	mov r24,YH
	rcall sendASCII
	cpi YL,0x10
	brcc SEE18
	ldi r24,'0'
	call sendCmdByte
SEE18:  
	mov r24,YL
	rcall sendASCII         ;print address
	ldi r24,':'
	call sendCmdByte

	rcall RdFlashWord      	;get token word from Flash, YH=page address
							;returns: r25 is HighByte, r24 LowByte
	cpi r24,0x08
	brne SEE20
	cpi r25,0x95
	brne SEE20
	ldi r25,HIGH(NSEMIS)	;special case
	ldi r24,LOW(NSEMIS)     ;replace RET Opcode directly by name
	rjmp SEE45
SEE20:
	adiw YL,1               ;16 bit token
	cpi r24,0x0C 			;JMP Opcode?
	brne SEE22
	cpi r25,0x94
	brne SEE22
	ldi r25,HIGH(NDOELSE)	;(NGOO)		;special case
	ldi r24,LOW(NDOELSE)    ;replace opcode by name
	rjmp SEE45

SEE22:
	cpi r24,0x0E			;CALL opcode?
	brne SEE25
	cpi r25,0x94
	brne SEE25
	rcall RdFlashWord      	;get token word from memory, YH=page address
	adiw YL,1

SEE25:
;Test for rcall command
	mov ZH,r25
	andi ZH,0xF0
	cpi ZH,0xD0
	brne SEE30

;Retransform rjmp code into absolute code address
; ***************************
;rcall machine code has top nibble D. Because call opcode is already separated
;and then an absolute memory addresse is returned, for a call command
;here the top nibble never can be a D (techn.possible exception ATmega1284).
				;target address = Diff. + memory pointer + 1
				;memory pointer is already incremented
	mov ZL,YL           
	mov ZH,YH
	com r24
	com r25
	adiw r24,1              ;two's complement because difference always negative
	andi r25,0x0F           ;mark out rjmp opcode
							;in rjmp representation r25 is second byte
	sub ZL,r24              ;due to backward reference
	sbc ZH,r25              ;target is always ACTUAL-Difference
	mov r24,ZL
	mov r25,ZH

SEE30:
	cpi r25,HIGH(USERFLASH)	;fixed 06Sept23
	brcs SEE32
	cpi r24,LOW(USERFLASH)	;Kernel code at top of BootLoader Section
	brcc SEE35
SEE32:
	cpi r25,HIGH(KERNELTOP)
	brcc SEE45

SEE35:
;2.word of jmp command
;Retransform real code address into symbol table address
; ***************************
;Flash address is transformet into symbol table address
;search run through jump table / odd Word address after Word Hi r1,Lo r24
	ldi ZL,LOW(SYMBOLTABLE*2)       ;*2: lpm needs address in bytes
	ldi ZH,HIGH(SYMBOLTABLE*2)
SEE38:
	cpi ZH,HIGH(KERNELTOP*2)
	brcs SEE40
	rjmp nameError
SEE40:
;jump over name string	
	mov TEMP3,ZL
	mov TEMP4,ZH		;points to name string if case of success
	lpm TEMP1,Z+		;Z points to 1st byte of string
	andi TEMP1,0x0F		;remove flags
	clr TEMP2
	add ZL,TEMP1
	adc ZH,TEMP2		;Z points behind name string
;if count+1=odd, i.e.bitTEMP1,0=set,then add 1 for NullByte(AVRA assembler)
;is now placed between namen string and token value !
	sbrs TEMP1,0    
	adiw ZL,1
;jump over first word of jmp code
	adiw ZL,2
;Z points to jmp code now
;get kernel code address
	lpm TEMP1,Z+
	lpm TEMP2,Z+		;Z points to next name string 

	cp TEMP1,r24
	brne SEE38
	cp TEMP2,r25
	brne SEE38

;correspondence found:
	mov ZH,TEMP4					;contains found address of count byte
	mov ZL,TEMP3
	lsr ZH
	ror ZL							;contains word address of count byte
	mov r25,ZH
	mov r24,ZL

; ************************
SEE45:
	rcall token2Str         ;immediately prints token name string
;returns r25= Token Code High r24=Token Code Low,whose string was searched
;special cases first
	cpi r25,HIGH(JSEMIS)   
	brne SEE50
	cpi r24,LOW(JSEMIS)	;compare if Flash equals opcode RET
	brne SEE50
	pop ZH
	rjmp SEE90              ;end of code
SEE50:
;following token are followed by a parameter to be printed via terminal
	cpi r25,HIGH(JDOELSE)
	brne SEE52
	cpi r24,LOW(JDOELSE)
	brne SEE52
	rjmp SEE75
SEE52:
	cpi r25,HIGH(JDODO)	;JGOO
	brne SEE55
	cpi r24,LOW(JDODO)
	brne SEE55
	rjmp SEE75
SEE55:
	cpi r25,HIGH(JDOAGAIN)	;JGOO
	brne SEE58
	cpi r24,LOW(JDOAGAIN)
	brne SEE58
	rjmp SEE75
SEE58:
	cpi r25,HIGH(JDOLIT)
	brne SEE60
	cpi r24,LOW(JDOLIT)
	brne SEE60				 
	rjmp SEE75
SEE60:
	cpi r25,HIGH(JDOWHILE)  ;JIFGO
	brne SEE65
	cpi r24,LOW(JDOWHILE)
	brne SEE65
	rjmp SEE75
SEE65:
	cpi r25,HIGH(JDOIF)		;JIFNOTGO
	brne SEE68
	cpi r24,LOW(JDOIF)
	brne SEE68
	rjmp SEE75
SEE68:
	cpi r25,HIGH(JDOUNTIL)
	brne SEE70
	cpi r24,LOW(JDOUNTIL)
	brne SEE70
	rjmp SEE75
SEE70:  
	cpi r25,HIGH(JDOFOR)
	brne SEE72
	cpi r24,LOW(JDOFOR)
	brne SEE72
	rjmp SEE75
SEE72:  
	cpi r25,HIGH(JDOLOOP)
	brne SEE78
	cpi r24,LOW(JDOLOOP)
	brne SEE78
SEE75:  
	rcall RdFlashWord
	adiw YL,1
	push AVIFLAGS
	sbr AVIFLAGS,m_TEMPHEX
	push r24
	ldi r24,'('
	rcall sendCmdByte
	pop r24				
	rcall narrowSendWord	//leaves r25 unchanged
	ldi r24,')'
	rcall sendCmdByte
	pop AVIFLAGS
	pop ZH
	dec ZH
	tst ZH
	breq SEE85
	push ZH					//avoid line break for long printout
	rjmp SEE82
SEE78:  
	cpi r25,HIGH(JDOSTR)
	brne SEE82
	cpi r24,LOW(JDOSTR)
	brne SEE82
	rcall sendSPACE
SEE80:
	rcall RdFlashWord
	adiw YL,1
	tst r24
	breq SEE82
	call sendCmdByte
	tst r25
	breq SEE82
	mov r24,r25
	call sendCmdByte
	rjmp SEE80
SEE82:  
	pop ZH
	dec ZH
	breq SEE85
	rcall sendSPACE
	rjmp SEE15 
SEE85:
	wdr
	ldi ZH,5                ;positions per line
	call sendCRR
SEE88:  
	rjmp SEE15
SEE90:  
	pop AVIFLAGS
	ret


RdFlashWord:   ;*****************************************************
;control parameter: YH,YL undestroyed
;read Little Endian data from programm memory address YH,YL to r25,r24
;r25 is HighByte, r24 LowByte
;ZL,ZH destroyed
;read Word from Word address
;********************************************************************
	mov ZH,YH
	mov ZL,YL
	lsl ZL
	rol ZH          ;recalculate WORD- into BYTE address
	lpm r24,Z+
	lpm r25,Z
	ret


token2Str:   ;*******************************************************
;Version for temp.symbol table in internal EEPROM
;Parameter r25= Token Code High r24=Token Code Low,whose string is searched
;Return:dto
;destroys TEMP1,TEMP2,ZL,ZH
;recalculate RCALL command into abs.memory address
;********************************************************************
	cpi r25,HIGH(USERFLASH)	;fixed 06Sept23
	brcs TTS10
	cpi r24,LOW(USERFLASH)	;Kernel code at top of BootLoader Section
	brcc TTS20
TTS10:
	cpi r25,HIGH(KERNELTOP)
	brcc TTS60
TTS20:
;kernel token
	mov ZH,r25
	mov ZL,r24				;word address
	lsl ZL
	rol ZH					;byte address
	lpm	TEMP1,Z+			;Z points to count byte of found token
	andi TEMP1,0x0F			;remove flags

;Z points to first byte of string    
	mov r1,TEMP1       
	cpi TEMP1,12
	brcs TTS50
	ldi TEMP1,12
TTS50:  
	lpm r24,Z+
	call sendCmdByte
	dec TEMP1
	brne TTS50
	mov TEMP1,r1
	sbrs TEMP1,0			;take null fill byte into account
	adiw ZL,1
	mov r25,ZH
	mov r24,ZL				;byte pointer to jump code now
	lsr r25
	ror r24					;word pointer now
	rjmp TTS90

TTS60:
	mov r1,r25      		;release r25 for more important local use
	push r24
	push r25

;scan table of user sybols
	ldi ZL,LOW(USERSYMBTAB)
	ldi ZH,HIGH(USERSYMBTAB)

TTS65:
;evaluate rising up from bottomvon to higher addresses
	push ZL
	push ZH
	_READ_EEPR_SYMB
	mov TEMP1,r0
	push TEMP1
	cpi TEMP1,0xFF
	breq TTS70
	andi TEMP1,0x0F
	add ZL,TEMP1            ;ZH remains constant here
	inc ZL                  ;add bount byte too
	_READ_EEPR_SYMB
	cp r1,r0
	brne TTS70
;partial success, now check Token Low Byte
	adiw ZL,1
	_READ_EEPR_SYMB
	cp r24,r0
	breq TTS80              ;Success

TTS70:
	pop TEMP1
	pop ZH
	pop ZL
	andi TEMP1,0x0F       	;length of name
	subi TEMP1,(-3)         ;add 3 for:  count byte, 2 byte Token
	clr r0
	add ZL,TEMP1
	adc ZH,r0				;Z points to count byte of next name now	
	cpi ZH,HIGH(INTEEP)
	brcc TTS75              ;oveflow
	_READ_EEPR_SYMB
	mov r25,r0
	cpi r25,0xFF
	brne TTS65

TTS75:
;Token cannot be identified
	ldi r24,'?'
	call sendCmdByte
	call sendCmdByte
	call sendCmdByte
	ldi TEMP1,3
	rjmp TTS90

TTS80:
	pop TEMP1
	pop ZH
	pop ZL
	adiw ZL,1                ;points to first string byte
	cpi TEMP1,13
	brcs TTS85
	ldi TEMP1,13
TTS85:
	_READ_EEPR_SYMB
	mov r24,r0
	call sendCmdByte
	adiw ZL,1
	dec TEMP1
	brne TTS85
	pop r25
	pop r24    
TTS90:          
	ret


addressIntEep:   ;***************************************************
;write ZH,ZL into EEARH,L and TEMP1=1 into EECR
;saves some words of program code
;********************************************************************
	push TEMP1
	out EEARH,ZH
	out EEARL,ZL
	ldi TEMP1,1
	out EECR,TEMP1
	pop TEMP1
	ret


burnIntEep:   ;******************************************************
;burn data in TEMP1 at address ZH(High),ZL(Low) into internal EEPROM
;********************************************************************
	wdr
	out EEARH,ZH
	out EEARL,ZL
	out EEDR,TEMP1

	sbi EECR,EEMPE
	sbi EECR,EEPE
BR10:   
	sbic EECR,EEPE
	rjmp BR10
	ret


CBurn: ;*************************************************************
;write data in ZL at LOGIC BYTE address CBUFLO,CBUFHI into temp. SRAM
;increment COPLO
;Z and TEMP1 destroyed
;********************************************************************
	push ZL
	push ZH

	mov TEMP1,ZL			;keep in mind

	mov ZL,CBUFLO
	mov ZH,CBUFHI
	cpi ZH,HIGH(CBUFTOP)    ;must be on page limiz
	brcc CBN90              ;max.word lenght reached
	st Z,TEMP1

;increase COP:  
	lds r25,COPLO
	inc r25
	sts COPLO,r25
	brne CBN40
	lds r25,COPHI
	inc r25
	sts COPHI,r25
CBN40: 
	lds CBUFLO,COPLO
	lds CBUFHI,COPHI
	lds r25,DELTACFLO        
	sub CBUFLO,r25
	lds r25,DELTACFHI
	sbc CBUFHI,r25              ;CBUFHI/LO is abs. Byte-Pointer in CBUF
	pop ZH
	pop ZL
	ret

CBN90:
	rjmp memoryError


compiXToken:   ;******************************************************
;Tokentype-Parameter:ZH,ZL=word address (parameter for compiCall)
;Literal-Parameter TEMP5=HighByte, TEMP2=LowByte
;********************************************************************
	rcall compiCALL
	mov ZL,TEMP2
	rcall CBurn
	mov ZL,TEMP5
	rcall CBurn
	ret


compiCALL:   ;******************************************************
;Parameter ZH,ZL=  target address in WORDs
;check first, if difference to actual COP > +/- 2k words
;if yes then compile "call",else compile "rcall"
;to change from rcall to call compilation, calculate 12-Bit offset
;destroys r24,r25,ZL
;********************************************************************
	cpi ZH,HIGH(KERNELTOP)
	brcc CPC10
;redirect Z pointer from kernel jump table to real flash code address
	lsl ZL
	rol ZH			;into byte addresse
	adiw ZL,2		;flash code address = 2nd word of jmp instruction
	lpm r24,Z+
	lpm r25,Z
	mov ZL,r24		;ccmes back as word address
	mov ZH,r25
;end of redirection
CPC10:
	push ZH
	push ZL
	lds r24,COPLO
	lds r25,COPHI
	lsr r25
	ror r24         ;Byte-->Word address actual code pointer
	adiw r24,1      ;Atmel Maschinencode needs actual address+1
	sub r24,ZL
	sbc r25,ZH
	cpi r25,0x08    ;dez.2048 = 0x800
					;because no forward referenc, is COP>Kernel !
	brcs compiRCALL
CPC30:  
	ldi ZL,0x0E
	rcall CBurn
	ldi ZL,0x94     ;opcode 0x940E (call) in little endian
	rcall CBurn
	pop ZL          ;pushed ZL
	rcall CBurn
	pop ZL          ;pushed ZH
	rcall CBurn
	ret


compiRCALL:   ;******************************************************
;Parameter:
;ZH,ZL=difference target address (ZH,ZL?) and actual (Codepointer+1)
;in Flash(in WORDS)
;destroys r24,r25,ZL
;from this "rcall" is compiled
;calculation of differece in compiCALL
;********************************************************************
	pop ZL
	pop ZL          ;remove pushed ZH,ZL from Returnstack

	com r25         ;build one's complement
	com r24
	adiw r24,1      ;transform into two's complement

	andi r25,0x0F
	ori r25,0xD0
	push r25
	mov ZL,r24
	rcall CBurn
	pop ZL			;ZL = r25
	rcall CBurn
	ret

;====================================================================
;Primaries

READD:  ; ( a -- x ) ************************************************
; Read word. Big endian
;********************************************************************
	cli					;precaution
	nop
	mov ZL,TOSL
	mov ZH,TOSH
	andi ZL,0xFE		;even cell adjst
	ld TOSL,Z+
	ld TOSH,Z
	sei
	ret


READDM:  ; ( a -- b ) ***********************************************
;read single byte from SRAM to TOSL, TOSH=0
;SRAM is divided into 3 regions: registers, I/O, storage SRAM
;for access to I/O addresses 0..0x3F(dec63), 0x20(dec32)must be added
;to register address listed in atmega.....inc file !!
;specifically I/O peripherals 0. 31 are distinguished from CPU registers
;********************************************************************
	mov ZL,TOSL
	mov ZH,TOSH
	cpi ZL,64
	brcc RDM10
	adiw ZL,0x20
RDM10:
	ld TOSL,Z
	clr TOSH
	ret


WRITEE:   ; ( x a --  ) *********************************************
; Write word to SRAM starting from 0x100. Byte order big endian 
;********************************************************************
;range test, avoid overwrite essential system parameters
	cpi TOSH,HIGH(VA_VALUE)
	brcs WRT90
	cpi TOSL,LOW(VA_VALUE)
	brcs WRT90
	cpi TOSH,HIGH(ARRAYTOP)
	brcs WRT20
	breq WRT10
	rjmp WRT90
WRT10:
	cpi TOSL,LOW(ARRAYTOP)
	brcc WRT90
WRT20:
	mov ZL,TOSL
	andi ZL,0xFE		;even cell adjust
	mov ZH,TOSH
	ld TOSL,X+         	;pop from datastack 
	ld TOSH,X+
	st Z+,TOSL
	st Z,TOSH		
	ld TOSL,X+			;emulate DROP
	ld TOSH,X+		
	ret 
WRT90:
	rcall parameterErr


WRITEDM:   ; ( b a --  ) ********************************************
;Write single byte from TOSL, TOSH ignored
;SRAM is divided into 3 regions: registers, I/O, storage SRAM
;for access to I/O addresses 0..0x3F(dec63), 0x20(dec32) 
;must be added to register address listed in atmega.....inc file !!
;specifically I/O peripherals 0. 31 are distinguished from CPU registers
;********************************************************************
	mov ZL,TOSL
	mov ZH,TOSH
	ld TOSL,X+              ;pop from datastack
	ld TOSH,X+
	cpi ZL,64
	brcc WDM10
	adiw ZL,0x20
WDM10:
	st Z,TOSL
	rjmp DROP


WRITEEPR:   ; ( x EEPaddr --  ) *************************************
;write word from TOSL into EEPROM
;********************************************************************
	mov ZL,TOSL				;EEPROM address where to be written
	mov ZH,TOSH
	cpi ZH,HIGH(INTEEP)
	brcc WEP90

	ld TOSL,X+              ;pop word to be written from datastack
	ld TEMP1,X+				;stack uses little endian
	call burnIntEep
	adiw ZL,1
	mov TEMP1,TOSL			;in EEPROM big endian is used !!
	call burnIntEep
	rjmp DROP
		
WEP90:
	rjmp parameterErr


BSETT:  ; ( N x -- xmodified)  **************************************
; set bitN (0...15) of TOS
;********************************************************************
	rcall getBit
	or TEMP3,r24
	or TEMP4,r25
	mov TOSL,TEMP3
	mov TOSH,TEMP4
	ret

BCLRR:  ; ( N x -- xmodified)  **************************************
; clear bitN (0...15) of TOS
;********************************************************************
	rcall getBit
	com r24
	com r25
	and TEMP3,r24
	and TEMP4,r25
	mov TOSL,TEMP3
	mov TOSH,TEMP4
	ret


BTST:  ; ( N x -- TRUE|FALSE)  **************************************
; test bitN (0...15) of TOS
; return TRUE if set FALSE if cleared
; TRUE=1
;********************************************************************
	rcall getBit
	and TEMP3,r24
	and TEMP4,r25
	or TEMP3,TEMP4
	brne BTS10
	clr TOSL
	clr TOSH	
	ret	
BTS10:
	ldi TOSL,1
	clr TOSH	
	ret


getBit:   ;**********************************************************
;Parameter: NOS=Bitposition(0-15), TOS(Word to be masked)
;return:Word-Mask in r24,r25
;********************************************************************
	mov TEMP3,TOSL	;keep in mind
	mov TEMP4,TOSH
	ld TOSL,X+				;emulate DROP
	ld TOSH,X+		
	mov r25,TOSL	;TOSL bit number (0...15) from datastack
	cpi r25,16
	brcc BIP90
	ldi ZH,HIGH(BITMASK*2)
	ldi ZL,LOW(BITMASK*2)
	cpi r25,8
	brcc BIP20
;clear bits 8...15, transform bits 0...7 into mask
	add ZL,r25
	lpm r24,Z
	clr r25
	ret
BIP20:
;clear bits 0...7, transform bits 8...15 into mask
	subi r25,8
	add ZL,r25
	lpm r25,Z
	clr r24
	ret

BIP90:
	rjmp parameterErr


ARRAYY: ;(index -- absAddr) *****************************************
; *******************************************************************
#if (CPU==168)
	tst TOSH
	brne ARY10
	cpi TOSL,64
	brcs ARY20
ARY10:
	rjmp parameterErr
#endif
#if ((CPU==328) || (CPU==32) || (CPU==3244))
	tst TOSH
	breq ARY20
	rjmp parameterErr
#endif
#if ((CPU==644) || (CPU==1284))
	cpi TOSH,2
	brcs ARY20
	rjmp parameterErr
#endif

ARY20:
	ldi r25,HIGH(ARRAY)
	ldi r24,LOW(ARRAY)
	lsl TOSL
	rol TOSH				;WORD offset
	add TOSL,r24
	adc TOSH,r25
	ret


DROP:  ; ( x -- )  **************************************************
;********************************************************************
	ld TOSL,X+
	ld TOSH,X+
	ret


DUP:  ; ( -- x )  ***************************************************
;*******************d*************************************************
	st -X,TOSH
	st -X,TOSL
	ret


OVER:  ;  ( x2 x1 -- x2 x1 x2 )   ***********************************0
;********************************************************************
	ld r24,X+               ;copy NOS
	ld r25,X
	ld r24,-X
	rjmp ROT20


DNROT:  ;  ( x1 x2 x3 -- x3 x1 x2 )  ********************************
;********************************************************************
	rcall ROT
;  ... and continue

ROT:   ;  ( x3 x2 x1 -- x2 x1 x3 )  *********************************
;********************************************************************
	ld ZL,X+
	ld ZH,X+
	ld r24,X+
	ld r25,X+
ROT10:  
	st -X,ZH
	st -X,ZL
ROT20:  
	st -X,TOSH
	st -X,TOSL
	mov TOSL,r24
	mov TOSH,r25
	ret


SWAPP:  ;  ( x2 x1 -- x1 x2 )  **************************************
;********************************************************************
	ld r24,X+
	ld r25,X
	st X,TOSH
	st -X,TOSL
	mov TOSL,r24
	mov TOSH,r25
	ret


PICK:  ;*************************************************************
;drop TOS but keep n in mind. COPIES xn up to new TOS. Count starts at x1
;(xn x(n-1)...x2 x1 n - xn x(n-1)..x2 x1 xn)
;simple exmaple (x3 x2 x1 3 - x3 x2 x1 x3)
;********************************************************************
	mov TEMP1,XL		;restore XL later
	mov r25,XL
	ldi r24,LOW(DATASTACK)
	sub r24,r25
	dec r24				;ROLL parameter does not count
	lsr r24				;stack offset->index

	cp r24,TOSL
	brcs ROL90
	mov TEMP2,TOSL		;keep PICK depth parameter in mind	;
	tst TEMP2			;0 PULL doesn't make sense
	breq PIK80
	dec TEMP2			;compensate drop of PICK parameter

	lsl TEMP2
	add XL,TEMP2
	ld TOSL,X+
	ld TOSH,X			;remove item to be pulled, will be TOS later
	mov XL,TEMP1
PIK80:
	ret



ROLL:  ;*************************************************************
;drop TOS but keep n in mind. POPS xn up to new TOS. Count starts at x1
;(xn x(n-1)...x2 x1 n - x(n-1)..x2 x1 xn)
;simple exmaple (x3 x2 x1 2 - x3 x1 x2)
;********************************************************************
	mov TEMP1,XL		;restore XL later
	mov r25,XL
	ldi r24,LOW(DATASTACK)
	sub r24,r25
	dec r24				;ROLL parameter does not count
	lsr r24				;stack offset->index

	cp r24,TOSL
	brcs ROL90
	mov TEMP2,TOSL		;keep ROLL parameter in mind	;
	ld TOSL,X+
	ld TOSH,X+			;drop ROLL parameter anyway SILENTLY
	cpi TEMP2,2			;0 PULL, 1 PULL don't make sense
	brcs ROL80

	dec TEMP2			;compensate DROP
	dec TEMP2
	lsl TEMP2
	add XL,TEMP2
	ld TOSL,X+
	ld TOSH,X			;remove item to be pulled, will be TOS later
	dec XL
	mov ZL,XL
	mov ZH,XH
	dec ZL		;address next deeper item
ROL30:
//shift stack entries newer than the pulled one up, fill the gap
	ld r25,Z
	std Z+2,r25
	dec ZL
	cp ZL,TEMP1
	brcc ROL30

	inc TEMP1
	inc TEMP1
	mov XL,TEMP1	;adjust the Data Stack pointer
ROL80:
	ret

ROL90:
	rjmp parameterErr


INJECT:    ;*********************************************************
;pushes NOS between former x(n+1) and xn
;(x(n+1) xn ...x2 x1 n - x(n+1) x1 xn ... x2) 
;simple example (x3 x2 x1 2 -- x3 x1 x2)
;********************************************************************
	mov r25,XL
	ldi r24,LOW(DATASTACK)
	sub r24,r25
	dec r24				;ROLL parameter does not count
	lsr r24				;stack offset->index
	cp r24,TOSL	
	brcs INJ90

	mov TEMP2,TOSL		;keep INJECT parameter in mind	;
	ld TOSL,X+
	ld TOSH,X+			;drop INJECT parameter anyway SILENTLY
	cpi TEMP2,2			;0 INJECT, 1 INJECT don't make sense
	brcs INJ80

	dec TEMP2
	lsl TEMP2			;ajdust word offset to byte format

	mov TEMP1,XL		;restore XL later
	mov TEMP3,TOSL
	mov TEMP4,TOSH		;NOS to inserted later as new TOS

	ld TOSL,X+		
	ld TOSH,X			;make previous 3rd stack entry new TOS
	dec XL				;stack depth neutral

	mov ZL,XL
	mov ZH,XH			
	add TEMP2,XL		;shift stack top offset
INJ30:
//shift older stack entries, make a gap for item to be injected
	ld r25,Z
	subi ZL,2
	st Z,r25
	subi ZL,-3			;add 3
	cp ZL,TEMP2
	brcs INJ30
;insert TEMP3,4 = previous NOS at gap
	subi ZL,2
	st Z+,TEMP3
	st Z,TEMP4
	mov XL,TEMP1	;	adjust the Data Stack pointer
INJ80:
	ret

INJ90:
	rjmp parameterErr


SUBB:  ; ( x1 x2 -- X1 ) ********************************************
;********************************************************************
	clr TEMP1
	clr TEMP2
	ld r24,X+            
	ld r25,X+
	sub r24,TOSL
	sbc r25,TOSH
	brcc SUB80
	ldi TEMP1,1
SUB80:
	mov TOSL,r24
	mov TOSH,r25
	sts FCARRYL,TEMP1
	sts FCARRYH,TEMP2
	ret


ADDD:  ; ( x1 x2 -- X1 ) ********************************************
;********************************************************************
	clr TEMP1
	clr TEMP2
	ld r24,X+
	ld r25,X+
	add TOSL,r24
	adc TOSH,r25
	brcc ADD80
	ldi TEMP1,1
ADD80:  
	sts FCARRYL,TEMP1
	sts FCARRYH,TEMP2
	ret


INCT:   ;  ( x -- x+1 )  *********************************************
;********************************************************************
	clr TEMP1
	clr TEMP2
	inc TOSL
	brne INT10
	inc TOSH
	brne INT10
	ldi TEMP1,1
INT10:  
	sts FCARRYL,TEMP1
	sts FCARRYH,TEMP2
	ret


DECT:   ;  ( x -- x-1 )  *********************************************
;********************************************************************
	clr TEMP1
	clr TEMP2
	mov r24,TOSL
	mov r25,TOSH
	sbiw r24,1
	brcc DET10
	ldi TEMP1,1
DET10:
	mov TOSL,r24
	mov TOSH,r25
	sts FCARRYL,TEMP1
	sts FCARRYH,TEMP2
	ret


ANDD:  ;  ( x1 x2 -- X1 ) *******************************************
;********************************************************************
	ld r24,X+
	ld r25,X+
	and TOSL,r24
	and TOSH,r25
	ret


ORR:  ;  ( x1 x2 -- X1 )   ******************************************
;********************************************************************
	ld r24,X+
	ld r25,X+
	or TOSL,r24
	or TOSH,r25
	ret


XORR:   ;  ( x1 x2 -- X1 )   ****************************************
;********************************************************************
	ld r24,X+
	ld r25,X+
	eor TOSL,r24
	eor TOSH,r25
	ret


NOTT:  ; ( x -- /x )  ***********************************************
;********************************************************************
	com TOSH
	com TOSL              	;one's complement, bitwise inversion
	ret


ABSS:   ;  ( x -- |x| )  ********************************************
;********************************************************************
	sbrs TOSH,7
	ret                     ;is positive
NEGG:  ; ( x -- -x )  ***********************************************
;********************************************************************
	com TOSH                ;transform into one's complement
	com TOSL
	inc TOSL                ;transform into two's complement
	brne ABS80
	inc TOSH
ABS80:  ret


STARSIG:   ;  ( x1 x2 -- X1 )   ****************************************
; SIGNED !!  16x16->16 bit
; if result >16Bit then RUNTIME ERROR
;********************************************************************
	clr TEMP2
	ld r24,X+
	ld r25,X+
	sbrs r25,7
	rjmp STS10
	com r24
	com r25
	adiw r24,1              ;two's complement --> absolute value
	inc TEMP2               ;keep sign in mind for result
STS10:  
	mov ZL,TOSL
	mov ZH,TOSH
	sbrs ZH,7
	rjmp STS20
	com ZL
	com ZH
	adiw ZL,1               ;two's complement --> absolute value
	inc TEMP2               ;keep sign in mind for result
STS20:  
	rcall starSub
	or TEMP3,TEMP4          ;or TEMP3,TEMP3
	breq STS60
	sbrc ZH,7               ;absolute result max 15 Bit
	rjmp STS60
	rjmp runTimeErr         ;Result has too much Bits
STS60:
	sbrs TEMP2,0            ;factor is negative -> make two's coplement
	rjmp STS80
	com ZL
	com ZH
	adiw ZL,1
STS80:
	mov TOSL,ZL
	mov TOSH,ZH
	ret


starSub:   ;*********************************************************
;32 bit result
;r24,r25+ZL,ZH=muliplicands, TEMP3,4=result HIGH, ZL,ZH=result LOW
;********************************************************************
	clr     TEMP4           ;clear 2 highest bytes of result
	clr     TEMP3
	ldi     TEMP1,16        ;init loop counter
	lsr     ZH
	ror     ZL

SSU10:  
	brcc    SSU20           ;if bit 0 of multiplier set
	add     TEMP3,r24       ;add multiplicand Low to byte 2 of res
	adc     TEMP4,r25       ;add multiplicand high to byte 3 of res
SSU20:  
	ror     TEMP4           ;shift right result byte 3
	ror     TEMP3           ;rotate right result byte 2
	ror     ZH              ;rotate result byte 1 and multiplier High
	ror     ZL              ;rotate result byte 0 and multiplier Low
	dec     TEMP1           ;decrement loop counter
	brne    SSU10           ;if not done, loop more
	ret


DIVSIG:   ;  ( x1 x2 -- X1 )   **************************************
; SIGNED !!
;********************************************************************
	clr TEMP2
	sbrs TOSH,7
	rjmp DVS20
	inc TEMP2               ;keep sign in mind for result
	com TOSL
	com TOSH
	inc TOSL                ;two's complement --> absolute value
	brne DVS20
	inc TOSH
DVS20: 
	rcall divSig1616
	sbrs TEMP2,0
	rjmp DVS80
	com r24                 ;argument is negativ
	com r25                 ;make two's compement
	adiw r24,1
DVS80:  
	mov TOSL,r24
	mov TOSH,r25
	ret


MODSIG:   ;  ( x1 x2 -- X1 )   ****************************************
; SIGNED !!
; Vorzeichen = Vorzeichen des Dividenden = NOS
;********************************************************************
	clr TEMP2
	sbrs TOSH,7
	rjmp MDS20
	com TOSL
	com TOSH
	inc TOSL                ;two's complement --> absolute value
	brne MDS20
	inc TOSH
MDS20:  
	rcall divSig1616
	sbrs TEMP2,0
	rjmp MDS80
	com TEMP3                 ;negative result
	com TEMP4                 ;make two's compement
	inc TEMP3
	brne MDS80
	inc TEMP4
MDS80:  
	mov TOSL,TEMP3
	mov TOSH,TEMP4
	ret


divSig1616:   ;  ****************************************************
; basic routine for !! SIGNED !! DIV and MODD
; r24,r25= Dividend L/H, TOSL,TOSH=Divisor,TEMP3,TEMP4=Remainder L/H
; return: r24,r25
; after ATMEL appnote 200
;********************************************************************
	ld r24,X+               ;NOS = Dividend
	ld r25,X+
	sbrs r25,7
	rjmp DIV10
	com r24
	com r25
	adiw r24,1              ;two's complement --> absolute value
	inc TEMP2               ;keep sign in mind for result
DIV10:  
	mov TEMP3,TOSL
	or TEMP3,TOSH
	brne DIVsub
	rjmp runTimeErr

DIVsub:
;from here: r24/25=dividend, TOSH/TOSL=divisor TEMP3,TEMP4=reaminder
	clr TEMP3           	;clear remainder Low byte
	sub TEMP4,TEMP4     	;clear remainder High byte and carry
	ldi TEMP1,17        	;init loop counter
DIV40:  
	rol r24             	;shift left dividend
	rol r25
	dec TEMP1           	;decrement counter
	brne DIV50           	;if done return
	ret                        
DIV50:  
	rol TEMP3           	;shift dividend into remainder
	rol TEMP4
	sub TEMP3,TOSL      	;remainder = remainder - divisor
	sbc TEMP4,TOSH
	brcc DIV60           	;if result negative, restore remainder
	add TEMP3,TOSL      
	adc TEMP4,TOSH
	clc                     ;clear carry, not shifted into result
	rjmp DIV40           
DIV60:  					;else
	sec                     ;set carry to be shifted into result
	rjmp DIV40


STASMOD:   ;  ( xM1 xM1 xD-- xRem xQL xQH) **************************
; rule of three operation,32 bit result - plus return of 16 bit remainder
; if result is 16bit, TOS=0
; TOSL,TOSH=Divisor
;********************************************************************
	set
	rjmp SSL10


STASL:   ;  ( xM1 xM1 xD-- xQL xQH) ***********************************
; rule of three operation,32 bit result
; TOSL,TOSH=Divisor
;********************************************************************
	clt
SSL10:  
	rcall DNROT				;Divisor 3rd on stack
;multiplication first
	ld r24,X+
	ld r25,X+
	mov ZL,TOSL
	mov ZH,TOSH
	rcall starSub
	mov r24,TEMP3           ;Intermediate Result High Byte
	mov r25,TEMP4

	ld TOSL,X+
	ld TOSH,X+              ;Divisor

	rcall div3216

	brtc SSL20
	st -X,TEMP4             ;Remainder
	st -X,TEMP3
SSL20:
	st -X,ZH                ;Quotient Low Word
	st -X,ZL
	mov TOSL,r24            ;Quotient High Word
	mov TOSH,r25
	ret


div3216:   ;*********************************************************
; !! UNSIGNED 32/16-->16 Bit !! Division
; Parameter:
; ZL,ZH,r24,r25=Dividend L/H + Quotient L/H
; TOSL,TOSH=Divisor
; TEMP3,TEMP4=Remainder 16Bit
; after ATMEL appnote 200
;********************************************************************
	clr r0
	mov TEMP3,TOSL
	or TEMP3,TOSH
	brne DDV5
	rjmp runTimeErr
DDV5:
	clr TEMP3
	clr TEMP4
	clr YL           			;clear remainder Low byte
	sub YH,YH					;clear remainder High byte and carry
	ldi TEMP1,33        		;init loop counter
DDV10:  
	rol ZL
	rol ZH
	rol r24             		;shift left dividend
	rol r25
	dec TEMP1           		;decrement counter
	breq DDV40           		;if done
DDV20:  
	rol TEMP3
	rol TEMP4
	rol YL          			;shift dividend into remainder
	rol YH
	sub TEMP3,TOSL				;remainder = remainder - divisor
	sbc TEMP4,TOSH
	sbc YL,r0
	sbc YH,r0
	brcc DDV30          		;if result negative, restore remainder
	add TEMP3,TOSL
	adc TEMP4,TOSH
	adc YL,r0
	adc YH,r0
	clc                     	;clear carry to be shifted into result
	rjmp DDV10           		;else
DDV30:  
	sec                     	;set carry to be shifted into result
	rjmp DDV10

DDV40:  
	ret

; -------------------------------------------------------------------
;LOOPS

IFF:   ;( -- addr) **************************************************
;add jump address later at "addr"
;********************************************************************
	ldi ZL,LOW(JDOIF)
	ldi ZH,HIGH(JDOIF)
//get CALL instruction parameter from SYMBOLTABLE
	rcall compiCALL
	clr ZL                  ;insert provisional dummy jump parameter
	rcall CBurn
	rcall CBurn
	st -X,TOSH				;emulate DUP
	st -X,TOSL	
	lds TOSL,COPLO			
	lds TOSH,COPHI
	subi TOSL,2				;keep actual code pointer on TOS
	sbci TOSH,0				;for later insertion of jump address
	ret


THENN:  ;  ( addr -- )  *********************************************
;********************************************************************
	mov TEMP2,TOSL	
	mov TEMP5,TOSH		
	rcall compileBack
	ld TOSL,X+		;emulate DROP
	ld TOSH,X+
	ret


ELSEE:  ; ( addr -- addr')    ***************************************
;********************************************************************
	ldi ZL,0x0C             ;compile opcode "jmp"
	rcall CBurn
	ldi ZL,0x94
	rcall CBurn

	mov TEMP5,TOSH          ;save in mind
	mov TEMP2,TOSL

	lds TOSL,COPLO          ;save address for later fill in
	lds TOSH,COPHI

	clr ZL                  ;insert provisional dummy jump parameter 
	rcall CBurn
	rcall CBurn

; ... continue directly

compileBack:  ; ( -- )  ********************************************
; temporarily direct code pointer backwards, compile data 
; and reconstruct the code pointer
; temporary code pointer parameter on TEMP5(Hi) and TEMP2(Lo)
; actual code pointer is address to be post-inserted there
;********************************************************************
	lds r25,COPHI
	lds r24,COPLO		;keep actual Flash code pointer in mind
	sts COPLO,TEMP2
	sts COPHI,TEMP5;	;redirect temporarily for insertion of jump address

	mov TEMP3,r24		;actual code pointer is jump address
	mov TEMP4,r25 		;to be inserted at jump address handed via parameter
	lsr TEMP4
	ror TEMP3       	;transform BYTE- into WORD-address

	push r24			;keep in mind to reconstruct actual code pointer
	push r25
	mov CBUFLO,TEMP2	;calculate temp.SRAM code pointer from Flash pointer
	mov CBUFHI,TEMP5
	lds r25,DELTACFLO        
	sub CBUFLO,r25
	lds r25,DELTACFHI
	sbc CBUFHI,r25     	;CBUFHI/LO is abs. Byte-Pointer in CBUF (SRAM)
	mov ZL,TEMP3
	rcall CBurn
	mov ZL,TEMP4
	rcall CBurn

	pop r25
	pop r24

	sts COPLO,r24
	sts COPHI,r25
	mov CBUFLO,r24		;COPHI/LO to CBUFHI/LO calculation
	mov CBUFHI,r25
	lds r25,DELTACFLO        
	sub CBUFLO,r25
	lds r25,DELTACFHI
	sbc CBUFHI,r25   		
	ret


DOO:  ; ( -- addr)  *************************************************
;common start code DO...UNTIL, DO...WHILE and DO...AGAIN 
;puts address of BREAK target on data stack (to be inserted later) 
;parameter transfer in WORDs
;********************************************************************
;DODO is compiled with additional empty address parameter
	ldi ZL,LOW(JDODO)
	ldi ZH,HIGH(JDODO) 
//get CALL instruction parameter from SYMBOLTABLE
	rcall compiCALL
	clr ZL                  ;insert provisional dummy jump parameter
	rcall CBurn
	rcall CBurn
	st -X,TOSH				;emulate DUP
	st -X,TOSL				;preserve existing data stack, add one new item
	lds TOSL,COPLO          ;64k jump possible
	lds TOSH,COPHI
	ret


DODO:  ;  ( -- )  ***************************************************
;********************************************************************
	pop ZH			;program counter as address of DODO parameter
	pop ZL			;will be filled with BREAK address as parameter of DODO
	adiw ZL,1
	mov TEMP3,ZL	;increase and save as DOUNTIL..loopbackAddr on Returnstack
	mov TEMP4,ZH  	;this is the code address of token after DODO, too 
	
	sbiw ZL,1
	lsl ZL
	rol ZH
	lpm r24,Z+      ;get DODO param value (set by UNTIL...) in little endian
	lpm r25,Z	
		
	push r24        ;BREAK address LOW on Returnstack
	push r25        ;BREAK address HIGH on Returnstack
	push TEMP3      ;put DONEXT loopback address on Returnstack
	push TEMP4		;also is the program counter to be executed next
	ret



UNTIL:  ;   ( addr -- )   *******************************************
;********************************************************************
	ldi ZH,HIGH(JDOUNTIL)
	ldi ZL,LOW(JDOUNTIL)	;compile DOUNTIL
	rjmp AGN10


WHILE:  ; ( addr -- )    ********************************************
;********************************************************************
	ldi ZL,LOW(JDOWHILE)
	ldi ZH,HIGH(JDOWHILE)	;compile DOWHILE
	rjmp AGN10


AGAIN:  ; ( addr -- )    ********************************************
;********************************************************************
	ldi ZL,LOW(JDOAGAIN)	;=GOO
	ldi ZH,HIGH(JDOAGAIN)	;compile DOENDFOR
AGN10:
	mov TEMP2,TOSL
	mov TEMP5,TOSH          ;pointer behind parameter of DODO
	lsr TEMP5
	ror TEMP2               ;BYTE->WORD address
	rcall compiXToken       ;compile DOAGAIN or DOUNTIL or DOWHILE....
	subi TOSL,2             ;point to place holder
	sbci TOSH,0
	rcall THENN             ;compile parameter
	ldi ZH,HIGH(JRS1UP)
	ldi ZL,LOW(JRS1UP)
	rcall compiCall      	;compile RS-1UP
	ret


FORR:  ;  ( --- addr )  *********************************************
;puts address of BREAK target on stack (to be inserted later) 
;********************************************************************
;DOFOR is compiled with additional empty address parameter
	ldi ZL,LOW(JDOFOR)
	ldi ZH,HIGH(JDOFOR) 
//get CALL instruction parameter from SYMBOLTABLE
	rcall compiCALL
	clr ZL                  ;insert provisional dummy jump parameter
	rcall CBurn
	rcall CBurn
	st -X,TOSH				;emulate DUP
	st -X,TOSL				;preserve existing data stack, add one new item
	lds TOSL,COPLO			;COP handled as Byte-Address
	lds TOSH,COPHI         	;TOS=actual code pointer to insert jump address  
	ret


DOFOR:  ;  ( xstart xstop addr -- )  ********************************
;copy direction flag into Bit 15 BREAK address
;Variable address on TOS
;********************************************************************
;return stack 
;1.)actual program counter (word)
;2.)BREAK address,
;3.)address of loop index variable
;	bit15 contains index update direction bit (word)
;4.)STOP index (word)

;TOS = Pointer to memory cell of loop parameter
	ld TEMP1,X+     ;grab XSTOP-L from stack
	ld TEMP2,X+     ;grab XSTOP-H from stack
	ld TEMP3,X+     ;grab XSTART-L from stack
	ld TEMP4,X+     ;grab XSTART-H from stack
	clr r1
	cp TEMP1,TEMP3
	cpc TEMP2,TEMP4
	brge DFO10
	set
	bld r1,7     	;set bit of BREAK address if XSTOP<XSTART(signed compare)
DFO10:
	mov ZL,TOSL		;addressed variable holds loop index
	mov ZH,TOSH
	st Z,TEMP3      ;write start value into loop index variable
	std Z+1,TEMP4   ;TEMP3+4 now free again for other use

	pop ZH			;program counter as address of DOFOR parameter
	pop ZL			;will be filled with BREAK address as parameter of DOFOR
	adiw ZL,1
	mov TEMP3,ZL	;increase and save as DOLOOP loopback addr on Returnstack
	mov TEMP4,ZH  	;this is the code address of token after DOFOR, too 
	sbiw ZL,1
	lsl ZL
	rol ZH
	lpm r24,Z+      ;get BREAK address (set by LOOP) in little endian
	lpm r25,Z		;

//transfer parameters via return stack:
	push TEMP1      ;loop parameter final value-LOW on Returnstack
	push TEMP2      ;loop parameter final value-HIGH on Returnstack

	push TOSL       ;memory address-LOW on Returnstack
	or TOSH,r1       ;copy direction flag into Bit15
	push TOSH		;memory address-HIGH on Returnstack

	push r24        ;BREAK address LOW on Returnstack
	push r25        ;BREAK address HIGH on Returnstack

	push TEMP3      ;put DOLOOP loopback address LOW on Returnstack
	push TEMP4		;dto. HIGH also is the program counter to be executed next
	ld TOSL,X+		;emulate DROP
	ld TOSH,X+
	ret


LOOPP:  ;   ( addr -- )   *******************************************
;********************************************************************
	mov TEMP2,TOSL
	mov TEMP5,TOSH          ;pointer behind parameter of DOFOR
	lsr TEMP5
	ror TEMP2               ;BYTE->WORD address
	ldi ZH,HIGH(JDOLOOP)
	ldi ZL,LOW(JDOLOOP)
	rcall compiXToken       ;compile DOLOOP
	subi TOSL,2             ;point to place holder
	sbci TOSH,0
	rcall THENN             ;compile parameter
	ldi ZH,HIGH(JRS4UP)
	ldi ZL,LOW(JRS4UP)
	rcall compiCall      	;compile RS-4UP
	ret


DOLOOP:   ;  ( -- )  ***********************************************
;read direction flag from Bit 15 BREAK address
;if terminaton value(signed) > actual loop parameter,
;then decrease loop parameter
;********************************************************************
;return stack 
;1.)actual program counter (word)
;2.)BREAK address,
;3.)address of loop index variable
;	bit15 contains index update direction bit (word)
;4.)STOP index (word)

	wdr
	pop r1			;actual program counter HIGH
	pop r0			;actual program counter Low
	pop TEMP5       ;BREAK addr-HIGH.Bit15 contains up/down counting direction
	pop TEMP1		;remove BREAK address-LOW from Returnstack
	pop ZH          ;address of variable-HIGH with loop index
	pop ZL			;address of variable-LOW
	pop TEMP4       ;stop value-HIGH 
	pop TEMP3       ;stop value-LOW
;prepare return stack for loop repetition
	push TEMP3      ;pop/push
	push TEMP4 		;actual TEMP3,4 value available now for other calculation
	push ZL			;restore  variable address-LOW byte
	push ZH			;restore  variable address-HIGH byte
	push TEMP1		;restore BREAK address LOW byte
	push TEMP5		;restore BREAK address HIGH byte

	mov TEMP2,ZH	;bit7:loop index increasing or decreasing?
	andi ZH,0x7F	;clear flag
	ld r24,Z        ;get loop index from variable
	ldd r25,Z+1

;loop counter decreasing or rising ?
	andi TEMP2,0x80
	breq DLP20      ;Bit15 clear:jump because rising loop counter

;decreasing loop:
;loop with termination parameter was just executed
	cp TEMP3,r24
	cpc TEMP4,r25
	breq DLP60      ;this was loop with index == STOP
	rcall compareSigned
	tst TEMP3		;if zero, index is <= STOP
	brne DLP60
	sbiw r24,1      ;decreasing loop
	std Z+1,r25     ;actual parameter restored in VAR
	st Z,r24
	rjmp DLP40
DLP20:
;rising Loop:
;loop with termination parameter was just execute
	cp r24,TEMP3
	cpc r25,TEMP4
	breq DLP60      ;this was loop with index == STOP
	rcall compareSigned ;TEMP3/4 is STOP value, r24/25 is actual loop index
	tst TEMP3		;if zero, index is <= STOP
	breq DLP60
	andi TOSL,1		;not really necessary
	adiw r24,1     	;rising loop
	std Z+1,r25     ;actual parameter restored in VAR
	st Z,r24
DLP40:

;get loopback address from DOLOOP parameter
	mov ZH,r1
	mov ZL,r0
	lsl ZL
	rol ZH          ;WORD->BYTE address
	lpm r0,Z+
	lpm r1,Z
	push r0			;inits jump to DOLOOPparam,i.e. to code behind DOFORparam
	push r1
	ret

DLP60:
;End of loop:
;remove previous program counter
;set program counter to (BREAK address + 1) (word)
;loop data will be removed by subsequent RS-4UP
;update program counter
	push TEMP1
	push TEMP5
	ret


RS1UP:  ;  ( -- )  *************************************************

;********************************************************************
	pop TEMP2			;remove program counter from return stack
	pop TEMP1
	pop r24
	pop r24				;remove BREAK address
	push TEMP1			;restore program counter
	push TEMP2
	ret


RS4UP:  ;  ( -- )  *************************************************

;********************************************************************
	pop TEMP2			;remove program counter from return stack
	pop TEMP1

	pop r24				;remove BREAK address
	pop r24	

	pop r24				;remove loop index valiable address
	pop r24

	pop r24 			;remove STOP index
	pop r24	

	push TEMP1			;restore program counter
	push TEMP2
	ret


DOWHILE:   ; ( TRUE|FALSE  -- )  ************************************
;conditional jump Forth ?BRANCH (inverted TRUE/FALSE parameter)
;********************************************************************
	wdr                     ;keep do-while loop permanently active
	mov r24,TOSL
	mov r25,TOSH
	ld TOSL,X+				;emulate DROP
	ld TOSH,X+
	or r25,r24
	brne DOELSE            ;jump if TRUE
	rjmp DUN10


DOUNTIL: ;  *********************************************************
	wdr                     ;keep do-until loop permanently active
	mov r24,TOSL
	mov r25,TOSH
	ld TOSL,X+				;emulate DROP
	ld TOSH,X+
	or r25,r24
	breq DOELSE           	;jump if FALSE
DUN10:
	pop r25                	;pop Program Counter
	pop r24
	adiw r24,1
	push r24
	push r25				;new Program Counter to leave loop
	ret


DOIF:   ; ( TRUE|FALSE  -- )  ***********************************
;conditional jump, Forth ?BRANCH
;********************************************************************
	wdr                     ;keep do-until loop permanently active
	mov r24,TOSL
	mov r25,TOSH
	ld TOSL,X+				;emulate DROP
	ld TOSH,X+
	or r25,r24
	breq DOELSE           	;jump if FALSE
DIF10:
	pop r25                	;pop Program Counter
	pop r24
	adiw r24,1
	push r24
	push r25				;new Program Counter
	ret


DOAGAIN:  ; *********************************************************
	nop						;assign different code address
							;else same runtime code
DOELSE:  ;  ( -- )   ************************************************
;unconditional jump, Forth BRANCH
;********************************************************************
	wdr
	pop ZH                  ;pop Program Counter
	pop ZL
	lsl ZL 					;must be stored in WORD format
	rol ZH					;transform into byte format
	lpm r24,Z+             
	lpm r25,Z
	push r24
	push r25
	ret


BREAKK: ;( -- )  ****************************************************

;********************************************************************
	pop r24				;remove subroutine return addr from return stack
	pop r24 
;BREAK address is top of return stack now
	pop r25				;pop BREAK address
	pop r24
	push r24			;restore as break address
	push r25
	push r24
	push r25			;is actual program couter now to execute BREAK
	ret


CONTI: ;( -- )  *****************************************************

;********************************************************************
	pop TEMP2				;replace program counter with (BREAKaddr-2)
	pop TEMP1
	pop r25					;pop BREAK address
	pop r24					;keep in mind
	push r24				;and restore it
	push r25
;make new program counter now
	sbiw r24,2				;execute loop-terminator token
	push r24
	push r25
;BREAK-2 address is top of return stack now

//	ret
;leaving here would be a more simple CONTI, 
;which needs a corresponding FALSE or TRUE parameter for doUNTIL and doWHILE
;following avoids this and creates an always re-looping CONTI
;get code start address from rcall instruction
	mov ZL,r24  
	mov ZH,r25
	mov TEMP2,ZH			;keep loop end token address in mind
	mov TEMP1,ZL
	lsl ZL
	rol ZH
	lpm r24,Z+				;get loop end token value
	lpm r25,Z

//jmp CTI10	;dummy test
		
	cpi r25,0x94
	breq CTI10
;loop end token is RCALL instr.
	com r24
	com r25
//	adiw r24,1              ;two's complement because difference always negative
	andi r25,0x0F           ;mark out rjmp opcode specific high nibble (0xD)
							;in rjmp representation r25 is second byte
	sub TEMP1,r24           ;due to backward reference
	sbc TEMP2,r25           ;target is always ACTUAL-Difference
	rjmp CTI30

CTI10:
;loop end token is CALL instr.
	inc TEMP1
	brne CTI20
	inc TEMP2
CTI20:
	mov ZL,TEMP1
	mov ZH,TEMP2
	lsl ZL
	rol ZH
	lpm TEMP1,Z+				;get loop end token value
	lpm TEMP2,Z

CTI30:
;compare, if it is doLOOP, else emulate doAGAIN
	ldi ZL,LOW(JDOLOOP+1)
	ldi ZH,HIGH(JDOLOOP+1)
	lsl ZL
	rol ZH          ;recalculate WORD- into BYTE address
	lpm TEMP3,Z+
	lpm TEMP4,Z
	cp TEMP2,TEMP4
	brne CTI80
	cp TEMP1,TEMP3
	brne CTI80
	ret					;perform doLOOP with loop index update
CTI80:
	pop r25
	pop r24
	adiw r24,1			;increase program counter
	push r24
	push r25
	rjmp DOAGAIN		;;bruteforce loopback


RETURN:  ;  ( -- )   ************************************************
;********************************************************************
	pop TEMP2			;get program counter
	pop TEMP1
	ret

; -------------------------------------------------------------------

ZEQ:  ; ( x -- TRUE|FALSE )  ****************************************
;********************************************************************
	or TOSL,TOSH
	brne EQ10               ;jump if FALSE
	rjmp EQ20               ;TRUE


compareEQ:    ;******************************************************
;********************************************************************
	mov r24,TOSL			
	mov r25,TOSH
	ld TEMP3,X+				;emulate DROP and change new TOS value
	ld TEMP4,X+				;=original NOS
	cp TEMP3,r24
	cpc TEMP4,r25
	ret


UNEQU:  ; ( x2 x1 -- TRUE|FALSE )  **********************************
;********************************************************************
	rcall compareEQ			
	brne EQ20               ;jump if TRUE
	rjmp EQ10               ;FALSE

ULESS:  ; ( x2 x1 -- TRUE|FALSE )  **********************************
; unsigned compare !, TRUE if x2 < x1
;********************************************************************
	rcall compareEQ
	breq EQ10               ;FALSE
	brcs EQ20               ;TRUE
	rjmp EQ10               ;NOS>=TOS -->FALSE


UGRTR:  ; ( x2 x1 -- TRUE|FALSE )  **********************************
; UNsigned compare !, TRUE if x2 > x1
;********************************************************************
	rcall compareEQ
	breq EQ10               ;FALSE
	brcs EQ10               ;FALSE
	rjmp EQ20               ;TRUE


EQUAL:   ; ( x2 x1 -- TRUE|FALSE )  *********************************
;********************************************************************
	rcall compareEQ
	breq EQ20
EQ10:   
	clr TOSL                ;FALSE
	clr TOSH
	ret
EQ20:   
	ldi TOSL,1
	clr TOSH                ;TRUE
	ret


GRTR:   ; ( x2 x1 -- TRUE|FALSE )  **********************************
; signed compare, TRUE if x2 > x1
;********************************************************************
	rcall compareEQ			;returns:TOS as r25/24  NOS as TEMP4/TEMP3
	breq EQ10               ;equal=FALSE
	rcall compareSigned		;now TOS is original NOS and r24,r25 is orig. TOS!
	clr TOSH                
	mov TOSL,TEMP3
	ret


GRTREQ:  ; ( x2 x1 -- TRUE|FALSE )  *********************************
; signed compare !, TRUE if x2 >= x1
;********************************************************************
	rcall compareEQ			;returns:TOS as r25/24  NOS as TEMP4/TEMP3
	breq EQ20               ;equal=TRUE
	rcall compareSigned
	clr TOSH                
	mov TOSL,TEMP3
	ret


LESS:  ; ( x2 x1 -- TRUE|FALSE )  ***********************************
; signed compare !, TRUE if x2 < x1
;********************************************************************
	rcall compareEQ			;returns:TOS as r25/24  NOS as TEMP4/TEMP3
	breq EQ10				;equal=FALSE
	rcall compareSigned
	clr TOSH  
	com TEMP3            
	mov TOSL,TEMP3
	andi TOSL,1
	ret


LESSEQ:  ; ( x2 x1 -- TRUE|FALSE )  *********************************
; signed compare, , TRUE if x2 <= x1
;********************************************************************
	rcall compareEQ			;returns:TOS as r25/24  NOS as TEMP4/TEMP3
	breq EQ20               ;equal=TRUE
	rcall compareSigned
	clr TOSH 
	com TEMP3           
	mov TOSL,TEMP3 
	andi TOSL,1
	ret


compareSigned:  ; ( x2 x1 -- TRUE|FALSE )  **************************
;signed compare !, TRUE if NOS(TEMP4,3) >= TOS(r25.24), 
;equality has been checked before
;here TEMP4/TEMP3 is original NOS and r25/r24 is orig. TOS!
;if NOS>=TOS: return TEMP1=1, else return TEMP1=0
;********************************************************************
	sbrc TEMP4,7		
	rjmp  CPS60
	cpi r25,0x80
	brcc CPS40
CPS10:
;NOS and TOS both are positive
	cp TEMP4,r25
	breq CPS20
	brcc CPS30
	clr TEMP3
	ret						;NOS<TOS
CPS20:
	cp TEMP3,r24
	brcc CPS50
CPS30:
	clr TEMP3
	ret						;NOS<TOS or NOS==TOS
CPS40:
;NOS is positive, TOS is negative, i.e. NOS>TOS
CPS50:
;NOS and TOS have same sign but NOS>=TOS
	clr TEMP3
	inc TEMP3
	ret
CPS60:
;NOS is negative
	cpi r25,0x80
	brcc CPS10				;NOS and TOS both are negative,
							;same  handling as both positive
;NOS is negative and TOS is positive, i.e. NOS<TOS
	clr TEMP3
	ret


SHIFTT:  ; ( x b -- X )  ********************************************
; b positive;x gets shifted left over b positions (b = 0 .. 15)
; b negative:gets shifted right over -b positions (b = -1 .. -15)
; unsigned logical shift. Use CARRY for ROTATE
;********************************************************************
	clr TEMP1
	clr TEMP2
	sbrc TOSH,7
	rjmp RSHIFT
LSH2:   
	cpi TOSL,17				;shift by 16 useful for ROTATE (do SHIFT CARRY OR)
	brcs LSH10
	jmp runTimeErr
;right-hand bits are inserted by 0.Left shifted-out bits are shifted to FCARRY
LSH10: 
	ld r24,X+				;indirect DROP: word to be shifted
	ld r25,X+
LSH20:  
	tst TOSL
	breq LSH40
	lsl TEMP1
	rol TEMP2
	lsl r24
	rol r25
	brcc LSH30
	ori TEMP1,1
LSH30:
	dec TOSL
	rjmp LSH20
LSH40:  
	mov TOSL,r24
	mov TOSH,r25
	sts FCARRYL,TEMP1
	sts FCARRYH,TEMP2
	ret

RSHIFT:  ; ******************
;transform ABS(TOS)
	com TOSH                ;transform into one's complement
	com TOSL
	inc TOSL                ;transform into two's complement
	brne RSH2
	inc TOSH
RSH2:   
	cpi TOSL,17				;shift by 16 useful for ROTATE (do SHIFT CARRY OR)
	brcs RSH10
	jmp runTimeErr
;ledt-hand bits are inserted by 0.Right shifted-out bits are shifted to FCARRY
RSH10:  
	ld r24,X+				;indirect DROP: word to be shifted
	ld r25,X+
RSH20:  
	tst TOSL
	breq LSH40
	lsr TEMP2
	ror TEMP1
	lsr r25
	ror r24
	brcc RSH30
	ori TEMP2,0x80
RSH30:  
	dec TOSL
	rjmp RSH20


KEYQ:  ;  ( -- FALSE | count ) **************************************
;********************************************************************
	st -X,TOSH
	st -X,TOSL				;release TOS
	sbrs YFLAGS,GETVABC						
	rjmp KYQ10				;due to CTRL_ABC, KEY must be ignored
	clr TOSH				;else competition with pullCmdRxBuf
	clr TOSL
	ret

KYQ10:
#if (CPU==3244)		
	lds TEMP2,USBRXTAILH
	lds TEMP1,USBRXTAILL
	lds TOSH,USBRXHEADH
	lds TOSL,USBRXHEADL
	cp TOSH,TEMP2
	brcs KYQ30
	brne KYQ20
	cp TOSL,TEMP1
	brcs KYQ30
	breq KYQ80
KYQ20:
;HEAD is higher than TAIL
	sub TOSL,TEMP1
	sbc TOSH,TEMP2
	ret
KYQ30:
;HEAD is lower than TAIL
	ldi r25,EP2_SIZE
	add TOSH,r25
	sub TOSL,TEMP1
	sbc TOSH,TEMP2
	ret
KYQ80:
	clr TOSH
	clr TOSL
	ret
#else
	clr TOSH				;buffer is always one full 0x100 page
	lds TOSL,CMDRXHEADL
	lds TEMP1,CMDRXTAILL
	cp TOSL,TEMP1
	brcs KYQ30
	breq KYQ80
;HEAD is higher than TAIL
	sub TOSL,TEMP1
	ret
KYQ30:
;HEAD is lower than TAIL
	ldi TOSH,1
	clr TEMP2
	sub TOSL,TEMP1
	sbc TOSH,TEMP2
	ret
KYQ80:
	clr TOSL
	ret
#endif


KEY:  ;  ( -- b )  **************************************************
;********************************************************************		
	wdr
	sbrc YFLAGS,GETVABC		;else competition with pullCmdRxBuf		;
	rjmp KEY				;deadlock possible if GETVABC fails???

KEY10:
	wdr
;checks USART1 RX Buffer, T-Flag is set if byte(s) received
	call pullCmdRxBuf		;received byte = TEMP1 ..
	brtc KEY10...
	st -X,TOSH
	st -X,TOSL				;release TOS
	clr TOSH
	mov TOSL,TEMP1
	ret


DOTDECI:  ;  ( x -- ) ***************************************************
;always send number in decimal format
;********************************************************************
	cbr AVIFLAGS,m_TEMPHEX
	clr TEMP5				;triggers signed sendWord
	rjmp DOT10


DOTHEX:  ;  ( x -- ) ***************************************************
;always send number in hexa-decimal format with preceeding 0x
;********************************************************************
	sbr AVIFLAGS,m_TEMPHEX
	clr TEMP5				;triggers signed sendWord
	rjmp DOT10


DOTUNSIG:  ;  ( x -- ) ***************************************************
;always send number unsigned in active number base
;********************************************************************
	sbr AVIFLAGS,m_TEMPHEX
	sbrs AVIFLAGS,HEX
	cbr AVIFLAGS,m_TEMPHEX
	clr TEMP5
	inc TEMP5				;triggers UNsigned sendWord				;	
	rjmp DOT10


DOT:  ;  ( x -- ) ***************************************************
;always send number signed in actual number base without preceeding char
;********************************************************************
	sbr AVIFLAGS,m_TEMPHEX
	sbrs AVIFLAGS,HEX
	cbr AVIFLAGS,m_TEMPHEX
	clr TEMP5				;triggers signed sendWord
DOT10:
;send SPACE plus TOS in actual number base
	mov r24,TOSL
	mov r25,TOSH
	call sendWord
	call sendSPACE
	ld TOSL,X+				;emulate DROP
	ld TOSH,X+		
	ret 


DOTSTRING:  ;  (  -- ) **********************************************
;only printable characters are safe !
;********************************************************************
;compile string until " and terminate with 0
	ldi ZL,LOW(JDOSTR)
	ldi ZH,HIGH(JDOSTR)
//replace call to jump table by call code code
	call compiCALL
	push XL
	push XH
	mov XL,STRSTART         ;actual<--next
	ldi XH,HIGH(TIB)
	clr STRINGLEN
DTQ10:  inc STRINGLEN
	ld ZL,X+
	cpi ZL,'"'
	breq DTQ20
	call CBurn              ;compile string
	rjmp DTQ10
DTQ20:
	add STRSTART,STRINGLEN
	inc STRSTART            ;point to next stringtoken
	clr ZL
	call CBurn              ;compile Nullbyte as delimiter
	sbrc STRINGLEN,0        ;length of string incl.Nullbyte even ?
	call CBurn              ;if not, add extra Nullbyte
	pop XH
	pop XL
	ret


EMIT:  ;  ( b -- )  *************************************************
;********************************************************************
;send byte in 8-bit format
	mov r24,TOSL
	call sendCmdByte
	rjmp DROP


DECIM:  ;  ( -- )  **************************************************
;********************************************************************
	cbr AVIFLAGS,m_HEX
	clt
	rjmp HEX10


HEXX:  ;  ( -- )  ***************************************************
;********************************************************************
	sbr AVIFLAGS,m_HEX
	set
HEX10:
	sbrc AVIFLAGS,COMPILE
	ret

	bld AVIFLAGS,HEXBACK		;only store in interpreting state
	ret


MSWAIT:  ;  ( x -- )  ***********************************************
;countdown is handled in timer0Interrupt
;BLOCKING
;example: 1000 MS.....  blocks during the countdown
;blocking gets released by terminal input CTRL_R
;********************************************************************
	sts MSCNTL,TOSL
	sts MSCNTH,TOSH
	ld TOSL,X+				;emulate DROP TOS
	ld TOSH,X+
MS10:
	wdr
	rcall KEYQ				;break blocking command?
	mov r24,TOSL
	mov r25,TOSH
	ld TOSL,X+				;emulate DROP TOS
	ld TOSH,X+
	or r24,r25
	breq MS20
	sbrc YFLAGS,GETVABC		;11July23 CTRL_R must be igored due to CTRL_ABC  
	rjmp MS20				;else competition of pullCmdRxBuf
	call pullCmdRxBuf
	cpi TEMP1,CTRL_R		;release blocking
	breq MS80
MS20:
	nop
	lds r24,MSCNTL
	lds r25,MSCNTH
	tst r24
	brne MS10
	tst r25
	breq MS80
	rjmp MS10
MS80:  
	clr r24
	sts MSCNTL,r24			;terminate MS-process in any case
	sts MSCNTH,r24
	ret


TIX:  ;  ( x -- )  **************************************************
;NON-BLOCKING countdown in steps of 1/10 seconds
;coutndown is handled in timer0Interrupt
;actual countdown level (remaining time in 1/10s units) is read out with TIME
;********************************************************************
;load millisecunds delay for countdown
	sts TIXCNTL,TOSL
	sts TIXCNTH,TOSH
	rjmp DROP


TIME:  ;  ( -- x )  *************************************************
; returns TIX countdown level (remaining time in 1/10s units)
;********************************************************************
	cli                 
	st -X,TOSH
	st -X,TOSL
	lds TOSL,TIXCNTL
	lds TOSH,TIXCNTH
	nop
	sei
	ret


SLEEPP:   ;  ( -- )  ************************************************
;go into Standby mode.
;********************************************************************
	sbrc AVIFLAGS,COMPILE
	ret						;don't execute in compiling mode
	
#if ((CPU==168) || (CPU==328))
	ldi r25,(1<<PCINT20)|(1<<PCINT16) //PD4 and PD0(RXD0)
	sts PCMSK2,r25
	ldi r25,1<<PCIE2
	sts PCICR,r25				;enable PinChange interrupt on PD4 and PD0

	wdr
	in r25,MCUSR				;disable watchdog
	andi r25,~(1<<WDRF)
	out MCUSR,r25
	lds r24,WDTCSR
	ori r24,(1<<WDCE)|(1<<WDE)	;double step init necessary
	clr r25
	sts WDTCSR,r24
	sts WDTCSR,r25

	clr r25						;turn ADC off 
	sts ADCSRA,r25
 #ifdef LEONARDO
	sbi PORTD,TXLED         ;switch LED on again
 #else
	cbi PORTD,LED           ;switch LED on again
 #endif

	ldi r25,1<<SM1
	out SMCR,r25				;select PowerDown sleep mode
	ldi r25,(1<<SM1)| (1<<SE)
	out SMCR,r25
#if (CPU==328)
	in r24,MCUCR				;MCUCR????????????????
	ori r24,1<<BODS				;disable BODS ???? doesn't work
	mov r25,r24
	ori r25,1<<BODSE
	out MCUCR,r25
	out MCUCR,r24
#endif
	sleep						;SLEEP !!!
	clr r25
	out SMCR,r25				;disable Sleep

	wdr
;re-init Watchdog 
	ldi r24,0x1E            	;double step init necessary
	ldi r25,0xE             	;1sec timeout
	sts WDTCSR,r24
	sts WDTCSR,r25

	clr r25						;deactivate PinChange interrupt on PD4,PD0
	sts PCICR,r25

	call delay	

	ldi r24,'^'
	call sendCmdByte
	lds r24,LEDAUTO
	cpi r24,1
	breq SLP10
	clr LEDCNT					;24Aug23
 #ifdef LEONARDO
	cbi PORTD,TXLED         	;switch LED on again
 #else
	sbi PORTD,LED          		;switch LED on again
 #endif
SLP10:
	ret
#endif

#if ((CPU==644) || (CPU==1284))
	ldi r25,(1<<PCINT28)|(1<<PCINT24) //PD4 and PD0(RXD0)
	sts PCMSK3,r25
	ldi r25,1<<PCIE3
	sts PCICR,r25				;enable PinChange interrupt on PD4 and PD0

	wdr
	in r25,MCUSR				;disable watchdog
	andi r25,~(1<<WDRF)
	out MCUSR,r25
	lds r24,WDTCSR
	ori r24,(1<<WDCE)|(1<<WDE)	;double step init necessary
	clr r25
	sts WDTCSR,r24
	sts WDTCSR,r25

	clr r25						;turn ADC off 
	sts ADCSRA,r25
	cbi PORTB,LED

	ldi r25,1<<SM1
	out SMCR,r25				;select PowerDown sleep mode
	ldi r25,(1<<SM1)| (1<<SE)
	out SMCR,r25

	in r24,MCUCR
	ori r24,1<<BODS				;disable BODS ???? doesn't work
	mov r25,r24
	ori r25,1<<BODSE
	out MCUCR,r25
	out MCUCR,r24

	sleep						;SLEEP !!!
	clr r25
	out SMCR,r25				;disable Sleep

	wdr
;re-init Watchdog 
	ldi r24,0x1E            	;double step init necessary
	ldi r25,0xE             	;1sec timeout
	sts WDTCSR,r24
	sts WDTCSR,r25

	clr r25						;deactivate PinChange interrupt on PD4,PD0
	sts PCICR,r25

	call delay	
	ldi r24,'^'
	call sendCmdByte
	lds r24,LEDAUTO				;24Aug23
	cpi r24,1
	breq SLP10
	clr LEDCNT
	sbi PORTB,LED           	;switch LED on again
SLP10:
	ret
#endif

#if (CPU==32)
	in r25,MCUCSR
	andi r25,~(1<<ISC2)
	out MCUCSR,r25
	in r25,GICR
	ori r25,1<<INT2
	out GICR,r25				;low level interrupt on PB2

	wdr
	in r24,WDTCR
	ori r24,(1<<WDTOE)|(1<<WDE)	;double step init necessary
	clr r25
	out WDTCR,r24
	out WDTCR,r25

	clr r25						;turn ADC off 
	out ADCSR,r25
	cbi PORTB,LED

	in r25,MCUCR
	ori r25,1<<SM1
	out MCUCR,r25				;select PowerDown sleep mode
	ori r25,(1<<SM1)| (1<<SE)
	out MCUCR,r25
	sleep						;SLEEP !!!
	in r25,MCUCR						
	andi r25,~((1<<SM1)| (1<<SE))
	out MCUCR,r25				;disable Sleep

	wdr
;re-init Watchdog 
	ldi r24,0x1E            	;double step init necessary
	ldi r25,0xE             	;1sec timeout
	out WDTCR,r24
	out WDTCR,r25

	in r25,GICR
	andi r25,~(1<<INT2)
	out GICR,r25				;disable falling edge interrupt on PB2

//	call initUSART0				;re-init USART removed 24Aug23
	call delay	
	ldi r24,'^'
	call sendCmdByte
	lds r24,LEDAUTO				;24Aug23
	cpi r24,1
	breq SLP10
	clr LEDCNT
	sbi PORTB,LED           	;switch LED on again
SLP10:
	ret
#endif


DOLIT:  ;  ( -- x )  ************************************************
;********************************************************************
	st -X,TOSH
	st -X,TOSL				;emulate DUP
	pop r25					;pop Program Counter
	pop r24
	mov ZL,r24
	mov ZH,r25
	lsl ZL
	rol ZH
	lpm TOSL,Z+
	lpm TOSH,Z
	adiw r24,1				;new Program Counter
	push r24				;restore
	push r25
	ret


DOSTR:  ;  ( -- x )  ************************************************
;********************************************************************
	pop ZH                  ;pop Program Counter
	pop ZL
	lsl ZL                  ;WORD into BYTE Pointer
	rol ZH
DST10:  
	lpm r24,Z+
	lpm r25,Z+
	tst r24					;null byte terminates string
	breq DST20
	call sendCmdByte       	;send byte "raw" in 8-bit format
	tst r25					;null byte terminates string
	breq DST20
	mov r24,r25
	call sendCmdByte
	rjmp DST10
DST20:  
	lsr ZH					;BYTE back in WORD Pointer
	ror ZL
	push ZL                 ;new Program Counter
	push ZH
	ret
